// Default user id
var userid = "Admin";
// Default user password
var password = "Admin";

var genericQueryID = "9b181387-479c-4e7c-a5a7-aa8eeef893eb";

var QEFName = "QEF10_4_2_229";
// WebForms Url
var qisurl = location.protocol + "//" + location.host + "/"+QEFName+"/webmodules/webforms";
// Session ID
var sid = null;
// Repository ID
var rid = "COOPP21";
// Repsository configuration Name
var cnm = "BaseConfiguration";
// Repsository configuration ID
var cid = "5e992b1f-294e-46d0-a122-57a7a4db172b";
// Repsository Language Code
var lcd = "en-US";
// Object ID for some BusinesProcessNetwork in Repository
var oid = "e47f354a-ee23-4b9a-9b32-68ee5c0b4f8d";
// Default data type
var datatype = "json";



// Default session settings
var $QisSession = { Cache: {} };
var $ConfigurationInfo = {};
var $TemplateSettings = {};
var $QepSettings = {
	MiscLabels: {},
	Definitions: {
		ListView: true
	}
};

//Global repository object
var $$ = new RepositoryObject();

// Disable browser cache
$.browserCache = $.noop;

// Settings container
var $settings = $("#wsSettings");

// Examples
var $content = $("div.content").html();

// Existing configuration
var storageKey = "__qdo__" + location.host + "_" + location.pathname.replace(/\//g,"");
var userConfig = window.localStorage.getItem(storageKey);  

if (userConfig) {
	var $userConfig = $.parseJSON(userConfig);
	qisurl = $userConfig["WebService"] || qisurl;
	rid = $userConfig["RepositoryId"] || rid;
	cnm = $userConfig["ConfigurationNm"] || cnm;
	cid = $userConfig["ConfigurationId"] || cid;
	lcd = $userConfig["LanguageCode"] || lcd;
	oid = $userConfig["ObjectId"] || oic;
	datatype = $userConfig["DataType"] || datatype;
	userid = $userConfig["Login"] || userid;
	password = $userConfig["Password"] || password;
}

$settings
	.find("#WebService").val(qisurl).end()
	.find("#RepositoryId").val(rid).end()
	.find("#ConfigurationId").val(cid).end()
	.find("#ConfigurationNm").val(cnm).end()
	.find("#LanguageCode").val(lcd).end()
	.find("#ObjectId").val(oid).end()
	.find("#Login").val("Admin").end()
	.find("#Password").val("Admin").end()
	.find("#JSON").prop("checked", datatype.match(/json/i)).end()
	.find("#XML").prop("checked", !datatype.match(/json/i)).end()
	.find("#settingsSave").on("click", function(e){
		e.preventDefault();
		qisurl = $settings.find("#WebService").val();
		rid = $settings.find("#RepositoryId").val();
		cnm = $settings.find("#ConfigurationNm").val();
		cid = $settings.find("#ConfigurationId").val();
		lcd = $settings.find("#LanguageCode").val();
		oid = $settings.find("#ObjectId").val();
		userid = $settings.find("#Login").val();
		password = $settings.find("#Password").val();
		datatype = $settings.find("#JSON").is(":checked") ? "json" : "xml";
		
		$userConfig = {
			WebService: qisurl,
			RepositoryId: rid,
			ConfigurationNm: cnm,
			ConfigurationId: cid,
			LanguageCode: lcd,
			ObjectId: oid,
			DataType: datatype,
			Login: userid,
			Password: password
		};
		
		window.localStorage.setItem(storageKey, window.JSON.stringify($userConfig));
		
		$("body").find(".content").empty().html($content);
		init();
	}).end();

(init = function () {
	var wsurl = qisurl + "/qiswebservice.svc";

	$("button.edit, button.run").attr("disabled", "disabled");
	
	$("a").each(function(){
		var href = $(this).attr("href").replace(/{wsurl}/gi, wsurl);
		var text = $(this).text().replace(/{wsurl}/gi, wsurl);
		$(this).attr("href", href).text(text);
	});

	$("h5").each(function(){
		if ($(this).children().length) {return;}
		var text = $(this).text().replace(/{wsurl}/gi, wsurl);
		$(this).text(text);
	});
	
	$.fn.qtip = function(){ if (arguments.length){ return null; } return this; };
	
	wsurl += "/" + datatype;

	$.ajaxSetup({
		contentType: "application/json; charset=utf-8",
		dataType: datatype,
		cache: false
	});
	
	$.alertDialog = function(content, type) {
		var width = Math.min($("body").width(), 400);
		var $alert = $("<div/>").addClass("alert fade in alert-" + (type ? type : "info"))
			.append("<a href=\"#\" class=\"close\" data-dismiss=\"alert\">&times;</a>")
			.append(content)
			.css({
				"width": width + "px",
				"position": "fixed"
			});
			
			var $cnt = $("div.alert-container");
			if (!$cnt.length) {
				$cnt = $("<div/>").prependTo($("body"))
					.addClass("alert-container")
					.css({
						"top": "0",
						"position": "relative",
						"margin": "0px auto",
						"height": "0px",
						"width":  width + "px",
						"z-index": 1000
					});
			}
			
			$cnt.html($alert);
				
		return $alert;
	};
	
	$.fn.handleErrorText = function(){
		var xhr = arguments[0] || {}; 
		if (!xhr.responseText) {
			return this;
		}
		
		var text = xhr.responseText;
		var idx1 = text.indexOf("'");
		var idx2 = text.substr(idx1+1).indexOf(".");
		
		text = text.substr(idx1+1,idx2);
		if (text) {
			this.append("<div style=\"margin-top:5px\"><i>" + text + "</i></div>");
		}
		
		return this;
	};
	
	$.alertDialog("<strong>Connecting...</strong><br/><small>" + wsurl + "</small>", "info");

	$.fn.collapsed = function(){
		var lvl = arguments[0] || 0;
		$(this).find(".level" + lvl).find(".collapser").click();
	};
	
	$.fn.toXMLString = function(){
		var text = this.text() || "";
		return "<textarea style=\"border:0; background-color: transparent; width: 100% !important; height: auto; overflow: hidden\">" + text + "</textarea>";
	};
	
	$.fn.getXMLAttr = function(){
		if (!arguments.length) {
			return this;
		}
		var attr = arguments[0];
		var text = $("<root>" + this.get(0).firstChild.textContent + "</root>")
			.find(attr).text();
		return text;
	};
	
	$.fn.xmlView = function(){
		if (!arguments.length) {
			return;
		}
		var data = arguments[0];
		this.append($(data).toXMLString());
		var height = this.find("textarea").get(0).scrollHeight;
		this.find("textarea").height(height + 10);
	};
	
	$.fn.timer = function() {
		if (arguments[0] === false) {
			clearInterval($(this).data("timer"));
			var $cnt = $(this).find(".modal-footer");
			var elapsed = Math.floor(parseFloat($cnt.find(".timer").text()));
			var $smiley = $cnt.find(".smiley");

			if (elapsed<3) {
				$smiley.attr("src", "./images/smiley-green.png");
				$(this).find(".modal-header").toggleClass("bg-info bg-success");
			}
			else if (elapsed<6) {
				$smiley.attr("src", "./images/smiley-yellow.png");
				$(this).find(".modal-header").toggleClass("bg-info bg-warning");
			}
			else {
				$smiley.attr("src", "./images/smiley-red.png");
				$(this).find(".modal-header").toggleClass("bg-info bg-danger");
			}
			return $(this);
		}
		var $img = $("<image class=\"smiley\" src=\"./images/smiley.gif?_"+ (new Date()).getTime() + "\"/>");
		var $cnt = $(this).find(".modal-footer");
		$cnt.append($("<div/>").addClass("query-status")	
			.html($img).append("<span class=\"timer\">" + 0 + "s.</span>"));
		
		var timer = setInterval(function(){
			$cnt.find("span.timer").text(parseFloat(parseFloat($cnt.find(".timer").text()) + 50/1000).toFixed(2) + "s.");
		}, 50);
		$(this).parent().data("timer", timer);
		return $(this);
	};
		
	$.ajax({
		type: "POST",
		url: wsurl + "/login",
		data: JSON.stringify({
			authority:"", 
			authorityKind:"Local", 
			login: userid, 
			password: password
		})
	})
	.done(function(data){		
		var isXML = datatype.match(/xml/i);
		
		if (isXML) {
			sid = $(data).getXMLAttr("sessionId");
		}
		else {
			sid = $.parseJSON(data);
		}
		
		$QisSession = {
			LangCode: "en-US",
			HTMLBase: qisurl,
			HTMLLocation: qisurl + "/GeneratedHTML/" + rid,
			RepId: rid,
			ConfId: cid,
			ConfNm: cnm,
			UserInfo: {
				Sid: sid
			},
			FncQueue: [],
			Delegate: {}, 
			Cache: {},
			Init: {} 
		};
				
		$ConfigurationInfo = {
			Data: {
				0 : {
					Name: cnm,
					Id: cid
				}
			}
		};
		
		setTimeout(function(){
			$.alertDialog("<strong>Connected</strong><br/>Repository: "+ rid + " (" + cnm + ")", "success");
			setTimeout(function(){
				$(".alert-container").fadeOut();
			}, 2500)
		}, 500);
		
		$("button.edit, button.run").removeAttr("disabled");
		
		$.fn.modalDialog = function(title, content){
			var $modal = $("<div/>").addClass("modal fade").attr("role","dialog")
				.append($("<div/>").addClass("modal-dialog")
					.append($("<div/>").addClass("modal-content")
						.append($("<div/>").addClass("modal-header").addClass("bg-info")
							.append("<button type=\"button\" class=\"btn btn-primary pull-right\" data-dismiss=\"modal\">&times;</button>")
							.append("<h3 class=\"modal-title\">" + title + "</h4>"))
					.append($("<div/>").addClass("modal-body").append(content))
					.append($("<div/>").addClass("modal-footer"))))
				.appendTo($(this));
			$modal.modal({backdrop: "static"});
			if (arguments[2]) {
				$modal.find(".modal-footer").append($("<div/>").addClass("query-data").html($.parseHTML(arguments[2])));
			}
			$modal.on("hidden.bs.modal", function(e){ 
				setTimeout(function(){$modal.remove(),1000});
			});
			return $modal;
		};
		
		$.fn.presentData = function(data){
			var $result = this;
			try {
				var count = "";
				if (isXML) {
					count = $($($.parseXML($(data).text())).children()).find("Object").length;
				}
				else {
					count = $.parseJSON(data).length;
				}
				
				count = "(" + (count||1) + " items)";
				
				$result.timer(false)
					.find(".modal-body").text("Building data presentation..." + count);
				
				setTimeout(function(){
					$result = $result.find(".modal-body");
					$result.html(count.replace(/\(|\)/g,""));
					isXML ? 
						$result.xmlView(data) :
						$result.jsonView(data).collapsed(1);
					
				}, 50);
			}
			catch(e) {
				console.log("Error parsing data: " + e);
				$result.html("Error parsing data: " + e);
			}
		}
			
		$("pre").each(function(){
			var text = $(this).html();
			text = text.replace(/{wsurl}/gi, wsurl);
			text = text.replace(/{sessionid}/gi, sid);
			text = text.replace(/{repositoryId}/gi, rid);
			text = text.replace(/{configurationId}/gi, cid);
			text = text.replace(/{configurationId}/gi, cid);
			text = text.replace(/{languageCode}/gi, lcd);
			text = text.replace(/{objectid}/gi, oid);
			text = text.replace(/{dataType}/gi, datatype);
			text = text.replace(/{userid}/gi, userid);
			text = text.replace(/{password}/gi, password);
			$(this).html(text);
		});

		$("#exampleCOOP button.run").on("click", function () {
			var $result = $(this).next(".result");
			var query = $.trim($("#predefinedquery").find("option:selected").text().split("[")[0]);
			$result.empty().modalDialog("QSQL table valued expression ", "loading...", query).timer();
			
			$.ajax({
				type: 'POST',
				url: wsurl + "/QIS/" + sid + "/rep/" + rid + "/conf/" + cid + "/CSharpMethod/GWE_ServiceHandlers.GetGenericQueryFull?_t=" + (new Date()).getTime(),
				data: window.JSON.stringify({
					objectAttributes: [
						{Name:"GenericQuery", Format:"PlainText", Value: genericQueryID}
					]
				})
			})
			.done(function (result) {
				$result.timer(false)
					.find(".modal-body").text("Building data presentation...");
				
				var $queryresult = $.parseJSON(result);

				
				var $hdrs = $queryresult[0] || {Structure: []};
				var $data = $queryresult[1] || {aaData: []};
				
				if (!$data.aaData.length) {
					$result.find(".modal-body").text("No data found!");	
					return;
				}
				
				if (!$hdrs.Structure.length) {
					$.each($data.aaData[0], function(key, $v){
						$hdrs.Structure.push({
							Name: key,
							Header: key,
							Visible: true
						});
					})	
				}
				
				var $table = $("<table />").width("100%").addClass("table table-bordered")
					.append("<thead></thead><tbody></tbody>");
				
				var $clgrp = $table.find("colgroup");
				var $thead = $table.find("thead");
				var $tbody = $table.find("tbody");
				
				var $tr = $("<tr/>").appendTo($thead);
				$.each($hdrs.Structure, function (idx, val) {
					if (val.Visible) {
						$("<th scope='col'/>").html(val.Header).appendTo($tr);
					}
				});
					
				$.each($data.aaData, function (idx, $d) {
					$tr = $("<tr/>").appendTo($tbody);
					$.each($hdrs.Structure, function (key, $hdr) {
						if ($hdr.Visible) {
							var $item = $d[$hdr.Header]||$d[$hdr.Name];
							if (typeof $item.Value !== "undefined") {
								if(typeof $item.Value == "string")
								{
									$item = $item.Value;
									
								}
								else if($item.Value.length > 0)
								{
									$item = $item.Value[0].Name
								}
								else
								{
									$item = "";									
								}
							}
							var $td = $(key==0 ? "<th scope='row'/>" : "<td/>").appendTo($tr);
							$item = String($item).replace("1900 01 01","").replace(" 01.00", "");
							$td.html($item);
						}
					});
				});
				
				$result.find(".modal-body").html($table);
			})
			.fail(function(xhr){
				$result.timer(false)
					.find(".modal-body").html("Failed: " + arguments[2]).handleErrorText(xhr);
			});
		});		
		
		$(function(){
			$("button.edit").each(function(){
				var $btn = $(this);
				$btn.on("click", function(){
					var $pre = $(this).parent("pre").removeClass("bg-info");
					if ($btn.data("edit")){
						$btn.html("Edit").data("edit", false);
						$pre.addClass("bg-success").removeClass("bg-warning")
							.children("code").attr("contentEditable", false);
						$pre.off("keydown");
						hljs.highlightBlock($pre.find("code").get(0));
						window.sessionStorage.setItem(storageKey + "_js", window.JSON.stringify($pre.find("code").html()));
				}
					else {
						$btn.html("Save").data("edit", true);
						$pre.addClass("bg-warning").removeClass("bg-success")
							.children("code").attr("contentEditable", true).attr("spellcheck", false);
						$pre.on("keydown", function(e){
							var key = e.which || e.keyCode;
							if (key == 9){
								e.preventDefault();
								$.insertTab();
							}
						});						
					}
				});
			});
			
			$("textarea").on("input", function(){
				var query = $(this).val().replace(/\n|\r|\t/g," ")
					.replace(/\s{2,}/g, " ").replace(/"/g, "\\\"");
				var $code = $(this).parents("pre").find("code .query");
				if ($code.length) {
					if (query) {
						$code.html("\"" + query + "\"");
					}
					else {
						$code.html("\"{query}\"");
					}
				}
			});
			
			var jsStore = window.sessionStorage.getItem(storageKey + "_js");
			if (jsStore) {
				var data = $.parseJSON(jsStore);
				$(".js-console").find("code").html(data);
			}
		});

	})
	.fail(function(){
		$.alertDialog("<strong>Failed</strong><br/><small>" + arguments[2] + "</small>", "danger");
	});
}).call();

$(function () {
	var popoverContent = function(){
		var type = "smiley" + $(this).data("type");
		var text =  "";
		if (typeof window[type] === "function") {
			text = window[type].call();
		}
		return text;		
	} 
	$(".smiley-thumb .alert").popover({
		trigger: "hover",
		html: true,
		content: popoverContent,
		placement: $(window).width()>800 ? "right" : "bottom"
	});
});

var smileyhappy  = function(){
   var content = "<image src=\"./images/target-hit.png\"/><span>Less than 2 seconds to get data.</span>";
   return content;
};
var smileyimpatient = function(){
	var content = "<image src=\"./images/target-hit2.gif\"/><span>Less than 6 seconds to get data.</span>";
	return content;
};
var smileyangry = function(){
	var content = "<image src=\"./images/target-miss.png\"/><span>More than 6 seconds to get data.</span>"
	return content;
};

var getRepositoryInfo = function() {
	return {
		FollowLinks: true,
		WebApplication: rid,
		Target: "blank",
		RepId: rid,
		ConfId: cid,
		ConfNm: cnm
	};
};

// insert tab character at cursor position
$.insertTab = function(){
	var text = arguments[0] || "\t";
	var sel, range, html;
    if (window.getSelection) {
        sel = window.getSelection();
        if (sel.getRangeAt && sel.rangeCount) {
            range = sel.getRangeAt(0);
            range.deleteContents();
            range.insertNode( document.createTextNode(text) );
        }
    } else if (document.selection && document.selection.createRange) {
        document.selection.createRange().text = text;
    }
};

$.fancybox = {};

hljs.initHighlightingOnLoad();

document.title = "QDO";

setTimeout(function(){
	$("head").append("<script src=\"js/kendo.custom.min.js\"></script>");
}, 5000);