﻿(function(){
	if (!window["$QisSession"]) {
		return;
	}
	
	($QisSession["DebugMode"]) ? $.ajaxSetup({ cache: false }) : $.ajaxSetup({ cache: true });
	
	if (!$.cookie("UserSid")) {
		var _sid = getUrlParams("sid");
		if (_sid) {
			$.cookie("UserSid", sid, {path:'/'});
		}
		else {
			$.browser.error("Invalid session, redirecting to login page...");
			endQisSession(location.href);
			return false;
		}
	}

	if ($.browserCache("get", "persistent-sessiontheme" + $QisSession.ConfId)) {
		var _theme = $.browserCache("get", "persistent-sessiontheme" + $QisSession.ConfId);
		if (!_theme.match(/default/i)) {
			$("head").append($("<link/>")
				.attr("href", "css/" + _theme + "/" + _theme + ".css")
				.attr("type", "text/css")
				.attr("rel", "stylesheet")
				.addClass("session-theme"));	
		}
	}
	
	$.getScript("js/breadcrumb/jquery.jBreadCrumb.1.1.min.js");
	$.getScript("js/datatables/jquery.dataTables.min.js");
	$.getScript("js/fancybox/jquery.fancybox.pack.js");
	$.getScript("js/fancytree/jquery.fancytree.all.js");
	$.getScript("js/flip/jquery.flip.min.js");
	$.getScript("js/megamenu/jquery.dcmegamenu.1.3.3.min.js");
	$.getScript("js/multiselect/jquery.multiselect.min.js");
	$.getScript("js/panel/jquery.ui.panel.min.js");
	$.getScript("js/qtip/jquery.qtip.min.js");
	$.getScript("js/window/jquery.window.min.js");	
})();

$.fn.instantClick = function() {
	var $dom = this;
	
	var ahref = arguments[0] || $dom.attr("href");
	var $pobj = new RepositoryObject($dom);
	var title = $pobj.Data.Name || $QisSession.RepName;
	var regex = new RegExp($QisSession.HTMLLocation, "gi");
	
	if ($pobj.Data.ConfId!==$QisSession.ConfId) {
		return location.href = ahref;
	}
	
	ahref = ahref.replace(regex, "") || "./";
	
	NProgress.configure({
		minimum: 0.1,
		trickle: false
	}).start();
		
	if ($.fancybox.isOpen) {
		$.fancybox.close();
		$.async(function(){
			History.pushState($pobj, title, ahref);
		}, 510);
	}
	else if ($.window.getAll().length) {
		$.window.closeAll();
		$.async(function(){
			History.pushState($pobj, title, ahref);
		}, 200);
	}
	else {
		History.pushState($pobj, title, ahref);
	}
	
	return $dom;
}

$.fn.onchange = function() {
	if (!arguments.length) {
		return this;
	}
	
	var $dom = this;
	var args = arguments[0];

	var executeHandler = function($dom) {
		if ($dom.get(0).nodeType === 1 
		&& $dom.isLoading()) {
			return;
		}
		var queue = $dom.data("onchange");
		if (!queue) {
			return $dom.onchange(false);
		}
		$.each($dom.data("onchange"), function(idx, func){
			func.call($dom);
		});
	};
	
	var updateHandler = function($dom){
		var queue = $dom.data("onchange") || [];
		var exist = false;
		var argstr = args.toString();
		$.each(queue, function(idx, func){
			var fstr = func.toString();
			if (argstr === fstr) {
				exist = true;
				return false;
			}
		});
		if (!exist) {
			queue.push(args);
			$dom.data("onchange", queue.unique());		
		}
	};
	
	switch(typeof args) {
		case "function":
			if ($.browser.compatible) {
				var text = $dom.text();
				var timer = $.async(function(){
					var chng = $dom.text();
					if (chng !== text) {
						text = chng;
						executeHandler($dom)
					}
				}, 50, true);
				$dom.data("onchange-timer", timer);
				updateHandler($dom);
			}
			else {
				$dom.bind("DOMSubtreeModified", function(){
					$.async(false, $dom.data("onchange-timer") || -1);
					var timer = $.async(function(){
						executeHandler($dom);
					}, 50);
					
					$dom.data("onchange-timer", timer);
					updateHandler($dom);
				});
			}
		
			break;
			
		case "boolean":
			if (args) {
				executeHandler($dom);
			}
			else {
				if ($.browser.compatible && $dom.data("onchange")) {
					$.async(false, $dom.data("onchange-timer"));
				}
				else {
					$dom.unbind("DOMSubtreeModified");
				}
				$dom.removeData("onchange-timer");
				$dom.removeData("onchange");
			}

			break;
			
		default: break;
	}
	
	return $dom;
}

$.fn.initNavSlideBtn = function () {
	var $dom = this;
	
	var $defs = arguments[0] || {FieldLeft: {}};
	var visible = true;

	if ($defs.FieldLeft.Visibility.match(/collapsed/i)) {
		visible = false;
	}
	else if ($defs.FieldLeft.Visibility.match(/hidden/i)) {
		return $dom.hide();
	}
	
	var icon = visible ? "ui-icon-triangle-1-w" : "ui-icon-triangle-1-e";
	
    $dom
		.data("collapsed", !visible)
		.css("width", "2em")
        .button({
            icons: { primary: icon, secondary: icon },
            text: false
        })
        .on($.browser.click, function () {
            $(this).toggleLeftContent($defs);
            return false;
        })
       .find(".ui-button-icon-secondary").css("right", "0.45em")
       .find(".ui-button-icon-primary").css("left", "0.45em");

    return $dom;
}

$.fn.initNavShareBtn = function () {
	var $dom = this;
	
    $dom
        .button({
            icons: { primary: "ui-icon-mail-closed" },
            text: false
        })
        .on($.browser.click, function () {
            var sMailTo = "mailto:";
            var sBody = $.LL("Hi") + "\n\n" + $.LL("I would like to share this page with you.") 
				+ "\n\n" + $.LL("Link:") + " " + $QisSession.HTMLLocation 
				+ "?oid=" + $$.Data.ObjId 
				+ "&cid=" + $QisSession.ConfId 
				+ "&lc=" + $QisSession.LangCode
                + "\n\n" + $.LL("Additional information:") + " "
                + "\n\n" + $.LL("Kind regards")
                + "\n" + $QisSession.UserInfo.FullName;

            sMailTo += escape("<" + $.LL("Insert Recipients Here") + ">") + "?subject=" + $.LL("Share:") + " " + escape(document.title) + "&body=" + escape(sBody);
            window.location.href = sMailTo;
            return false;
        });

    return $dom;
}

$.fn.initPrintPageBtn = function () {
	var $dom = this;
	
	var $defs = $QepSettings[$$.TemplateDefinition["SettingsFile"]];
	
	if (!$defs) {
		$dom.hide().remove();
		return $dom;
	}
	
	if (!$.keyCount($defs.Report)) {
		$dom.hide().remove();
		return $();
	}
	
    $dom
        .button({
            icons: { primary: "ui-icon-print" },
            text: false
        })
        .on($.browser.click, function (e) {
			e.preventDefault();

			$.PrintReport(function(){
				$.initPrintContent.apply(this, arguments);
			});
			
            return false;
        });

    return $dom;
}

$.fn.initNavSearchBtn = function () {
	var $dom = this;
	
	var oid = $QepSettings.Search.Query;
	var $parms = $QepSettings.Search.Parameters || {};
		
	if (!$.keyCount($parms) || !oid) {
		return $dom.hide();
	}
	
    $dom
        .button({
            icons: { primary: "ui-icon-search" },
            text: false
        })
        .on($.browser.click, function (e) {
			e.preventDefault();
			var searchvals = $.browserCache("get", "persistent-search-" + $QisSession.ConfId);
			
			$.SearchForm(searchvals, function(){
				var $form = this;
				var $parms = arguments[0] || $QepSettings.Search.Parameters;
				
				if (!$parms.length && !$.keyCount($parms)) {
					return;
				}
				
				var $search = {};
				
				$.each($parms, function(){
					var $field = $form.find("[name="+this.Attribute+"]");
					var val = null;
					if (this.Type === "MultiSelect") {
						val = $field.multiselect("getChecked").map(function(){
							return this.value;    
						}).get().join(",");
					}
					else {
						val = $field.val();
					}
					
					if (val) {
						$search[this.Attribute] = val;
					}
				});
				
				$.browserCache("set", "persistent-search-" + $QisSession.ConfId, window.JSON.stringify($search));
				$.initSearchQuery();
			})
		});

    return $dom;
}

$.fn.initNavLogoutBtn = function () {
	var $dom = this;
	
    $dom
        .button({
            icons: { primary: "ui-icon-locked" },
            text: false
        })
        .on($.browser.click, function () {
            endQisSession($QisSession.HTMLLocation, false);
            return false;
        });

    return $dom;
}

$.fn.initPersonalPageBtn = function () {
	var $dom = this;
	var ppage = arguments[0] || false;
    $dom
        .button({
            icons: { primary: ppage ? "ui-icon-home" : "ui-icon-person" },
            text: false
        })
        .on($.browser.click, function () {
            location.href = location.href.split("?")[0] 
				+ (ppage ? "" : "?pid=personal");
            return false;
        });

    return $dom;
}

$.fn.initNavCustomBtn = function () {
	var $dom = this;
	
	if (!arguments.length) {
		return $dom.hide();
	}
	
	var $opts = {
		Function: $.noop, 
		Parameter: { 
			Icon: "ui-icon-bookmark"
		}
	}
	
	if (arguments[0]) {
		$.extendSafely($opts, arguments[0]);
	}
	
    $dom
        .button({
            icons: { primary: $opts.Parameter.Icon },
            text: false
        })
        .on($.browser.click, function () {
			$opts.Function.call($opts.Parameter);
            return false;
        });

    return $dom;
}

$.fn.initLangChgBtn = function () {
	var $dom = this;
	
	if ($.keyCount($LanguageInfo.Data) < 2) {
		return $dom.hide();
	}
	
	var $langBtn = $QepSettings.Definitions.NavigationButtons.Language;
	
	if ($$.TemplateDefinition["SettingsFile"]) {
		$.extend(true, $langBtn, $QepSettings[$$.TemplateDefinition["SettingsFile"]]);
	}
	
	var indicator = $langBtn.Parameter ? eval($langBtn.Parameter.Indicator) : false;
	var text = $langBtn.Parameter ? eval($langBtn.Parameter.Text) : false;
	
	if (indicator) {
		var langname = String(getLanguageInfo($QisSession.LangCode).Name);
		$dom.html(langname.split("(")[0]);
	}
	
	$dom
        .button({
            icons: { primary: "ui-icon-flag" },
            text: text
        })
        .on($.browser.click, function () {
			$.LanguageSelector( function() {
				changeRepositoryLanguage.call(this);
			});
		});
		
	if (indicator) {
		$dom.addClass("css-init").css({
				"font-size": "11px",
				"padding": "4.8px 3px 3px 3px"
			})
			.find(".ui-icon")
				.html($("<img src=\"images/language/"+$QisSession.LangCode+".png\"/>")
					.css({
						"width": "16px",
						"margin": "-4px 0 0 -10px"
					})
				).css({
					"background": "none",
					"width": "16px",
					"padding": "4px",
					"text-indent": 0
				})
			.end()
			.find(".ui-button-text").css({
				"position": "relative",
				"padding": "0 4px 0 22px",
				"top": "-1px"
			})
			.end()
	}

    return $dom;
}

$.fn.initConfChgBtn = function () {
	var $dom = this;
	
	if ($.keyCount($ConfigurationInfo.Data) < 2) {
		return $dom.hide();
	}
	
	$dom
        .button({
            icons: { primary: "ui-icon-copy" },
            text: false
        })
        .on($.browser.click, function () {
            $.ConfigurationSelector(function(){
				var $data = this;
								
				var url = location.href.split("?")[0];
				var searchstr = window.location.search.slice(1).split("#")[0];
				var parameters = "";
				
				if (searchstr) {
					var parms = {};
					searchstr = searchstr.split("&");
					
					for (var i = 0; i < searchstr.length; i++)
					{
						var tmp = searchstr[i].split("=");
						parms[tmp[0].toLowerCase()] = unescape(tmp[1]);
					}
						
					$.each(parms, function(key, value) {
						if( key.toLowerCase().indexOf("cid") < 0) {
							parameters += "&" + key + "=" + value;
						}
					});
				}
				
				if (parameters) {
					url += "?";
					url += parameters ? parameters.substring(1) : "";
				}

				if ($data.Id != $QisSession.BaseConfId) {
					url += parameters ? "&" : "?";
					url += "cid=" + $data.Id;
				}
				
				$.browserCache("clear");
				location.href = url;
			})
			
            return false;
        });

    return $dom;
}

$.fn.initApplicationBtn = function () {
	var $dom = this;
	
	$dom
		.button({
            icons: { primary: "ui-icon-calculator" },
            text: false
        })
        .on($.browser.click, function () {
		var $sets = $$.TemplateDefintion ? $$.TemplateDefintion["SettingsFile"] : "Definitions";
		$.fancybox($("<div/>").width(400).css("text-align", "center").addClass("application-launch")
			.append($("<h2/>").html($QepSettings[$sets].NavigationButtons.Application.Parameter.Caption)));
				
		$.getJSON(initQisWebService({
			objid: $$.Data.ObjId,
			revid: $$.Data.RevisionId,
			confid: $$.Data.ConfId,
			wsfunction: "StartQLM"
		}))
		.done( function(data){
			var $data = data.length ? $.parseJSON(data) : {file:""};
			location.href = $QepSettings[$sets].NavigationButtons.Application.Location + "/" + $data.file;
			$.async(function(){
				$.fancybox.close();
			}, 2000);
		})
		.fail(function(xhr, result, error) {
			$.browser.error(error.message || error.description || error);
			$.async(function(){
				$("div.application-launch h2").html($.LL("Application launch failed!"));
			}, 2000);
		});
		return false;
        });

    return $dom;
}

$.fn.initAnalyticsBtn = function () {
	var $dom = this;
	
    $dom
        .button({
            icons: { primary: "ui-icon-signal" },
            text: false
        })
        .on($.browser.click, function () {
			if (!$QisSession.Addons.SBW) {
				var $cnt = $("<div />").width(450)
					.append("<h1>" + $.LL("Analytics not available") + "</h1>")
					.append("<div>" + $.LL("Social Behavior Warehouse is not enabled.") + "</div>")
				$.fancybox($cnt);
				return;
			}

			var $cnt = $("#dataCenter");
				
			if (!$cnt.find(".HTMLAnalyticsTab").length) {
				$.loader({text: $.LL("Initializing analytics")});
				$cnt.trigger("loadAnalytics");
			}
			else {
				var text = $cnt.find(".HTMLAnalyticsTab").css("display").match(/block/i) ?
					$.LL("Loading data") :
					$.LL("Loading analytics");
				$.loader({text: text});
			}
						
			$.async(function(){
				var flipped = $("#dataCenter").attr("flipped") == 1 ? 0 : 1;
				var color = $("#bar").css("background-color");

				var $data = $cnt.contents().detach();
			
				$cnt
					.css("background-color", color)
					.attr("flipped", flipped)
					.flip({
						color: $("#bar").css("background-color"),
						onBefore: function () {},
						onAnimation: function(){},
						onEnd: function () {
							$.async(function(){
								$.loader(false);
								$cnt.html($data);
								$.initPageContent(flipped);
							}, 150);
						}
					});

					return false;
			}, 250);
		});

    return $dom;
}

$.fn.toggleLeftContent = function () {
	var $dom = this;
	
    var collapsed = $dom.data("collapsed");
	
	var $defs = arguments[0] || $QepSettings[$$.TemplateDefinition["SettingsFile"]];
	var callb = arguments[1] || $.noop;

    $("html").css("overflow", "hidden");
    $("#dataCenter").css("width", "auto");

    var $left = $("#contentHeaderLeft, #contentLeft");
	var $right = $("#contentHeaderRight, #contentCenter"); 
	
	var defnW = $defs.FieldLeft.Width;
	var leftW = $left.data("leftW") || 
		( collapsed ? defnW : $left.outerWidth());
		
	var speed = 400;

    if (!collapsed) {
        $dom.button({
            icons: { primary: "ui-icon-triangle-1-e", secondary: "ui-icon-triangle-1-e" },
            text: false
        })
		.data({
			"collapsed": true,
			"paddingLeft": $left.css("padding-left"),
			"paddingRight": $left.css("padding-right")
		});

		$left.data("leftW", leftW)
			.animate({ 
				"width": 0,
				"padding-left": 0,
				"padding-right": 0
			},
			{
				duration: speed,
				easing: "easeOutCubic",
				complete: function(){
					$left.hide();
					callb.call();
				}
			});
		$left.data("collapsed", true).children()
			.animate({
				"margin-left": -leftW
			},
			{
				duration: speed,
				easing: "easeOutCubic"
            });
		$right.find("#dataCenter").children(".ui-widget")
			.animate({
				"width": "+=" + leftW
			},
			{
				duration: speed,
				easing: "easeOutCubic",
				complete: function(){
					$.adjustTemplate();
				}
			});
    }
    else {
        $dom.button({
            icons: { primary: "ui-icon-triangle-1-w", secondary: "ui-icon-triangle-1-w" },
            text: false
        })
		.data("collapsed", false);
        
        $left.show()
			.animate({ 
				"width": defnW,
				"padding-left": $dom.data("paddingLeft"),
				"padding-right": $dom.data("paddingRight")
			},
			{
				duration: speed,
				easing: "easeOutCubic",
				complete: function() {
					callb.call();
				}
            });
		$left.data("collapsed", false).children()
			.animate({
				"margin-left": 0
			},
			{
				duration: speed,
				easing: "easeOutCubic",
				complete: function(){
				}
            });
		$right.find("#dataCenter").children(".ui-widget")
			.animate({
				"width": "-=" + leftW
			},
			{
				duration: speed,
				easing: "easeOutCubic",
				complete: function(){
					$.adjustTemplate();
				}
			});
    }

    $dom
        .find(".ui-button-icon-primary").css("left", "0.45em")
        .find(".ui-button-icon-secondary").css("right", "0.45em");

    return $dom;
}

$.fn.jblur = function () {
	var $dom = this;
	
	var blurr = arguments.length ? arguments[0] : true;
	var calb = arguments[1] || $.noop;

	if ($.browser.compatible) {
		if (blurr) {
			$(".jbar").css({
				"background-color": "#f0f0f0",
				"opacity": 0.7
			});
		}
		return $dom;
	}
	
	if (typeof $domElementStack == "undefined") {
		$domElementStack = {};
	}
		
	$dom.each(function() {
		var domId = $(this).attr("id");
		
		switch (blurr) {
			case true:
				$domElementStack[domId] = $(this).clone(true);
				$(this).foggy();
				calb.call($(this));
			    break;
			
			default:
				if (!$(this).find(".foggy-pass-relative").length){
					return;
				}
				
				$(this).foggy(false);
				var $cnt = $domElementStack[domId];
				$.async(function(){
					$("#"+domId).replaceWith($cnt);
					$domElementStack[$cnt.attr("id")] = "";
					calb.call($cnt);
				}, 1000);
				break;
		}
	});
	
	return $dom;
}

$.fn.addDataTable = function () {
	var $dom = this;
	
    var $opts = {
		aLengthMenu: [[25, 50, 100, -1], [25, 50, 100, "All"]],
		aoColumns: [],
		bAutoWidth: false,
		bJQueryUI: true,
		iDisplayLength: 25,
		oLanguage: {
			sLoadingRecords: $.LL("Loading") + "..."
		},
		oTable: false,
		qWidth: null,
		sDom: 'R<"H"lfr>t<"F"ip>',
		sPaginationType: "full_numbers",
		onLoad: $.noop
    };
	
	$.extend( $.fn.dataTableExt.oSort, {
		"html-asc": function ( a, b ) {
			if ($.isNumeric(a) && $.isNumeric(b)) {
				a = parseInt(a); b = parseInt(b);
			}
			return ((a < b) ? -1 : ((a > b) ? 1 : 0));
		},
		
		"html-desc": function ( a, b ) {			
			if ($.isNumeric(a) && $.isNumeric(b)) {
				a = parseInt(a); b = parseInt(b);
			}
			return ((a < b) ? 1 : ((a > b) ? -1 : 0));
		}
	});

    $dom.css({
        "padding": 0,
        "border-spacing": 0,
        "border-collapse": "collapse"
    });

    var $hdr = $dom.children("thead");
    var $bdy = $dom.children("tbody");

    if (!$hdr.length) {
        $dom.append("<thead/>");
    }

    if (!$bdy.length) {
        $dom.append("<tbody/>");
    }

	var $parms = arguments[0] || {};
    
	if ($hdr.length) {
		if ($parms) {
			if (!$parms.sScrollX) {
				delete $parms.oColReorder;
			}
			
			$.each($parms, function(key, val) {
				if (key == null || val == null) {
					return;
				}
				
				if (key.substring(0,1) == "s") {
					$opts.oLanguage[key] = val;
				}
				
				if (String(val).charAt(0) === "[" && String(val).charAt(String(val).length-1) === "]") {
					$opts[key] = eval(val);
				}
				else if (key === "iDisplayLength") {
					$opts[key] = parseInt(val);
				}
				else {
					$opts[key] = val;
				}
			});
		}

		var hdrLength = $hdr.find("th").length;
		if (!$opts.qWidth || String($opts.qWidth).toLowerCase() == "auto") {
			$opts.qWidth = new Array(hdrLength);
			for (var i=0; i<hdrLength; i++) {
				$opts.qWidth[i] = ($(this).data("width") + "px") || ((100/hdrLength) + "%");
			}
		}
		
		if (!$opts.aoColumns.length) {
			$.each($opts.qWidth, function(idx, val){
				$opts.aoColumns.push({sWidth: val});
			});
		}
		
		var oTable = $dom.dataTable($opts);
		
		var searchFilter = function(o) {
			var timeout = 0;
			var $flt = $('.dataTables_filter input');
			$flt.unbind('keypress keyup');
			$flt.bind('keypress keyup', function(e){
				$.async(false, timeout);
				var val = $flt.val();
				var key = e.which ? e.which : e.charCode;
				if (key == 13){
					o.fnFilter(val, null, false, true);
					$.async(function(){$flt.focus();});
				}
				else {
					timeout = $.async(function(){
						o.fnFilter(val, null, false, true);
					}, 2000);
				}
			});
		}
		
		var initialized = arguments[1] || false;
		if (!initialized) {
			$.async(function(){
				$.async(function(){
					if ( oTable.find("td").isLoading() ) {
						return;
					}
					
					$.async(false, this);
					try {
						oTable.fnDestroy();
						oTable.addDataTable($opts, true);
						searchFilter(oTable);
					} 
					catch(e) {
						oTable = $dom.addDataTable($opts, false);
					}
					
					$opts.onLoad.call(oTable);
				}, 250, true);
			}, 1000);
		}
		else {
			searchFilter(oTable);
		}

		var fixedLeftCol = (arguments[2] && $parms.sScrollX) ? arguments[2] : false;
		if (fixedLeftCol) {
			new $.fn.dataTable.FixedColumns( oTable );
		}
		
		if ($opts.oTable) {
			return oTable;
		}
    }
    
    return $dom;
}

$.fn.addDataTableRow = function () {
    if (!arguments.length) {
        return this;
    }
	
	var $dom = this;
    
	$dom.fnAddData(data);
	return $dom;
}

$.fn.addBlog = function () {
    if (!arguments.length) {
        return this;
    }
	
	var $dom = this;

    var $list = arguments[0];

    var $opts = {
        DisableLink: true,
		TemplateIcon: false,
		HeaderAttribute: null,
		HeaderCaption: null,
        ShowResponsible: false,
        ResponsiblePrompt: null,
        ResponsibleAttribute: null,
        ShowUniqueId: false,
        UniqueIdAttribute: null,
        ShowStatus: false,
        StatusPrompt: null,
        StatusAttribute: null,
        ContentPrompt: null,
        ContentAttribute: null,
        ShowProgress: false,
        ProgressHeaderLabel: null,
		ShowProgressBar: false,
        ProgressOpenPrompt: null,
        ProgressClosedPrompt: null,
        ProgressClosedAttribute: "Closed",
        MaxWidth: 600
    };

    if (arguments[1]) {
        $opts = $.extendSafely($opts, arguments[1]);
    }
	
    var $blog = $dom
		.empty()
        .addClass("blog")
        .css({
			"max-width": $opts.MaxWidth + "px"
		});

	if (!$list.length){
		$opts.ShowProgressBar = false;
	}
	
    if ($opts.ShowProgress) {
        var $progress = $("<div>")
			.addClass("progress")
			.css({
				"margin": "1em 0"
			})
            .append($("<span/>")
				.addClass("progresstext")
                .css({
                    "width": "250px",
                    "font-size": "1.3em",
                    "line-height": "0.75em",
                    "display": "table-cell",
                    "vertical-align": "top",
                    "color": "#333"
                })
				.append($("<span/>")
					.append($list.length)
					.append(" " + $opts.ProgressHeaderLabel)
					.css({
						"display": "block",
						"margin-left": ".5em"
					}))
                .append($("<span/>")
                    .addClass("progressvalue")
                    .html("0%")
                    .css({
                        "float": "right",
                        "position": "relative",
                        "right": "-3em",
                        "top": "-0.3em",
                        "font-size": "0.9em",
                        "color": "#000",
                        "text-shadow": "0 1px 0 #fff",
						"display": $opts.ShowProgressBar?"block":"none"
                    })
                )
                .append($("<span/>")
                    .addClass("progressstatus")
                    .css({
                        "color": "#666",
                        "font-size": "0.7em",
                        "position": "relative",
                        "float": "left",
                        "padding-left": "2em",
						"top": "0.5em",
						"display": $opts.ShowProgressBar?"block":"none"
                    })
                ))
			.append($("<span/>")
				.addClass("progressbar")
				.css({
					"width": "350px",
					"display": ($opts.ShowProgressBar ? "table-cell" : "none")
				})
				.progressbar({
					max: $list.length,
					value: 0
				}))
			.appendTo($blog);
    }

    $.each($list, function () {
        $("<div/>")
			.addBlogItem(this, $opts, $blog)
			.appendTo($blog);
	});
	
   return $dom;
}

$.fn.addBlogItem = function () {
    if (arguments.length<2) {
        return this;
    }
	
	var $dom = this;
	
    var $obj = arguments[0];
    var $opts = arguments[1];
    var $blog = arguments[2];

    $dom
		.addClass("blogitem ui-widget-header ui-corner-all")
		.css({
			"padding": "2px",
			"margin": "10px 0 5px 0"
		});

    var $hdr, $rsp, $sts, $bdy;

    $hdr = $("<div/>")
        .addClass("blogheader ui-state-default ui-corner-top")
        .css({
            "padding": ".2em .5em",
            "font-size": "1.27em",
	    "line-height": "1.25em",
            "border-color": "#aaa"
        })
        .html($("<span/>")
            .css("width", $opts.MaxWidth - 100)
            .html($opts.HeaderAttribute 
					? $obj.HyperLink("", "", $opts.TemplateIcon, "left center", false)
						.text($obj.attr($opts.HeaderAttribute).text())
					: $obj.HyperLink("", "", $opts.TemplateIcon, "left center", false)))
        .appendTo($dom);
    
	if ($opts.HeaderCaption) {
		$hdr.children("span:first")
			.append($("<span/>")
				.css({
					"font-size": "0.7em",
					"display": "block"
				})
				.append($.LL($opts.HeaderCaption, $obj)));
	}
	
	if($opts.HeaderAttribute == "RatingScore") {
		$hdr.find("a").replaceWith($obj.attr($opts.HeaderAttribute).html())
	}
    else if ($opts.DisableLink) {
        $hdr.find("a")
			.disableHyperLink($opts.TemplateIcon?true:false);
	}

    if ($opts.ShowResponsible) {
        $rsp = $("<div/>")
            .addClass("blogcaption ui-state-active")
            .css({
                "padding": "0 0.4em",
                "border-color": "#aaa",
                "font-size": "0.95em",
                "line-height": "2em"
            })
            .appendTo($dom);
    }

    if ($opts.ShowStatus) {
        $sts = $("<div/>")
            .addClass("blogcaption ui-state-active")
            .css({
                "padding": "0 0.4em",
                "border-color": "#aaa",
                "font-size": "0.95em",
                "line-height": "2em"
            })
            .appendTo($dom);
    }

    if ($opts.ShowResponsible && $opts.ShowStatus) {
        $rsp.css({
            "display": "table-cell",
            "width": $opts.MaxWidth / 2 + 100
        })

       $sts.css({
           "display": "table-cell",
           "width": $opts.MaxWidth / 2 - 100
       })
    }

    $bdy = $("<div/>")
        .addClass("blogbody ui-state-active ui-corner-bottom")
        .css({
            "padding": "0.5em",
            "border-color": "#aaa",
            "font-size": "1em",
            "line-height": "1.4em",
            "text-shadow": "none"
        })
        .ajaxLoaderText()
        .appendTo($dom);
    
    $obj.init( function () {
        if ($opts.ShowUniqueId) {
            $hdr.append($obj.attr($opts.UniqueIdAttribute)
                .css({
                    "text-align": "right",
                    "font-size": "0.9em",
                    "line-height": "1.6em",
                    "display": "table-cell",
                    "width": "100px",
                    "vertical-align": "middle"
                })
            )
            .children()
                .css("display", "table-cell")
                .end()
        }

        if ($opts.ShowResponsible) {
            $rsp.empty()
				.append($("<span/>").html($opts.ResponsiblePrompt)
					.css({
						"display": "inline-block",
						"margin-right": "5px"
					}))
				.append($obj.attr($opts.ResponsibleAttribute).css("display", "inline-block"));
        }

        if ($opts.ShowStatus) {
            $sts.empty()
				.append($("<span/>").html($opts.StatusPrompt)
					.css({
						"display": "inline-block",
						"margin-right": "5px"
					}))
				.append($obj.attr($opts.StatusAttribute).css("display", "inline-block"));
        }

		if ($opts.ShowProgress) {
			var $bar = $blog.find(".progressbar");
			var val = $bar.progressbar("option", "value");
			var max = $bar.progressbar("option", "max");
            
			var updateprogressbar = function(val) {
				var pct = Math.ceil(100 * val / max);

				$bar
					.progressbar("option", "value", val)
						.find(".ui-progressbar-value").css("background", "#00dd00")
						.end()
					.siblings("span.progresstext")
						.children("span.progressvalue")
							.html(pct + "%")
							.end()
						.children("span.progressstatus")
							.empty()
							.append($("<span/>").css("color", "red").html((max - val + " " + $opts.ProgressOpenPrompt)))
							.append(" - ")
							.append($("<span/>").css("color", "green").html((val + " " + $opts.ProgressClosedPrompt)))
							.end();
			};
			
			var $attrval = $obj.attr($opts.StatusAttribute);
			if ($attrval.isLoading()) {
				$attrval.onchange(function(){
					if ($attrval.text() == $opts.ProgressClosedAttribute) {
						$attrval.onchange(false);
						updateprogressbar(++val);
					}
				})
			}
            else if ($attrval.text() == $opts.ProgressClosedAttribute) {
                updateprogressbar(++val);
            }
        }

		var $content = $obj.attr($opts.ContentAttribute);
		
        $bdy.empty()
			.append($("<div/>")
				.addClass("blogprompt genericprompt")
				.css({"font-weight": "bold", "margin-bottom": "3px"})
				.html($opts.ContentPrompt))
			.append($content)
			.find("p").css("margin",0);
	});
	
	return $dom;
}

$.fn.addPanel = function () {
	var $dom = this;
	
    if (!arguments.length) {
        return $dom;
    }
	
	var $opts = {
		title: "",
		collapsible: true,
		collapsed: false,
		hideempty: false,
		emptytext: "-",
		content: $.noop,
		counter: true,
		sequence: 0
	}
		
	if (arguments.length) {
		$opts = $.extendSafely($opts, arguments[0]);
	}
	
	if (String($opts.collapsed).match(/no/i)) {
		$opts.collapsed = false;
	}
	
	if (String($opts.collapsible).match(/no/i)) {
		$opts.collapsible = false;
	}
	
	if (String($opts.counter).match(/no/i)) {
		$opts.counter = false;
	}

    var prefix = "panel-";
	
	var specialChars = "!@#$^&%*()+=-[]\/{}|:<>?,.";
	for (var i = 0; i < specialChars.length; i++) {
		$opts.title = $opts.title.replace(new RegExp("\\" + specialChars[i], 'gi'), '');
	};
	
	var pid = prefix + $opts.title.replace(/ /g,"");
    var $panel = $dom.find("#" + pid);

    if ($panel.length) {
        $panel.empty();
    }
    else {
        $panel = $("<div />")
			.attr("id", pid)
			.addClass("panel")
    }

    $panel
        .append($("<h3/>")
			.html($opts.title)
			.disableSelection())
        .append($("<div/>"))
        .panel({
            "collapsible": $opts.collapsible,
            "collapsed": $opts.collapsed
        })
		.hide()
        .find(".ui-panel-header")
            .on($.browser.click, function () {
                $(this).find(".ui-panel-title-text").trigger($.browser.click);
				$.adjustScroll(); 
                return false;
            })
            .end()
        .find(".ui-panel-content")
            .css("font-family", $QepSettings.FontFamily)
            .end();
	
	if (!$opts.collapsible) {
		$panel.find(".ui-panel-title-text").css("margin-left", "8px");		
	}
	
	var $cnt = $panel.find(".ui-panel-content-text");
	
	if (typeof $opts.content == "function") {
		$cnt.html($opts.content.call($cnt));
	}
	else {
		$cnt.html($opts.content);
	}
	
	var txt = $.trim($cnt.text());
	var isloading = $cnt.isLoading();

	if (isloading) {
		if (!$opts.hideempty) {
			$cnt.css("min-height", "16px");
			$panel.show();
		}
	}
	else {
		if (!txt) {
			if (!$opts.hideempty) {
				$cnt.text($opts.emptytext);
			}
		}
		else {
			$panel.show();
		}
		if ($opts.counter) {
			$panel.addPanelCounter();
		}
	}

	$cnt.onchange(function(){
		var txt = $.trim($cnt.text());
		if (txt) {
			txt = txt.replace($opts.emptytext, "");
			if (txt) {
				$panel.show();
				if ($opts.counter) {
					$panel.addPanelCounter();
				}
			}
		}
		else {
			if ($opts.hideempty) {
				$panel.hide();
			}
			else {
				if ($cnt.find(".treeview").length) {
					$cnt.find(".treeview").html($opts.emptytext)
					$panel.find(".ui-panel-counter").text(0);
				}
				else {
					$cnt.html($opts.emptytext);
				}
			}
		}
		$.adjustScroll(); 
	});

	if (!$opts.sequence || $opts.sequence==-1) {
		$dom.append($panel);
	}
	else {
		$list = $dom.find(".panel");
		if (!$list.length) {
			$dom.append($panel);
		}
		else {
			var seq = parseInt($opts.sequence) <= 0 ? $opts.sequence+1  : $opts.sequence-1;
			$list.eq(seq).before($panel);
		}
	}
	
    return $dom;
}

$.fn.addPanelCounter = function () {
	var $dom = this;
	
	var num = arguments[0] || $dom.find(".links").data("counter");

	var $cnt = $dom.find(".ui-panel-content");
	var $txt = $cnt.find(".ui-panel-content-text");
	
	if ($.trim($txt.text())==($.LL("Loading") + "...") && num==null) {
		return $dom;
	}

	var count = num || $cnt.find("a.hyperlink").length;
	
	var $fld = $dom.find(".ui-panel-title:first");
	var $idx = $fld.children(".ui-panel-counter");
	
	if (!$idx.length) {
		$idx = $("<span/>")
			.addClass("ui-panel-counter")
			.appendTo($fld);
	}
	
	$idx.html(count);
		
	return $dom;
}

$.fn.makePanelAccordion = function() {
	var $dom = this;
	
	$dom
		.panel("destroy")
		.panel({"accordion": "accordion"})
		.toggleClass("accordion")
		.removeClass("ui-panel")
		.find(".ui-panel-content")
			.css("font-family", $QepSettings.FontFamily)
			.end();
	
	var $last = $dom.first();	
	
	$dom.each(function(){
		if (!$(this).find(".ui-panel-content").text()){
			$(this).css("display","none");
			return;
		}		
		$last = $(this);
	})
	
	$last.css("margin-bottom","6px")
		
	return $dom;
}

$.fn.removePanelAccordion = function() {
	var $dom = this;
	
	$dom
		.panel("destroy")
		.panel({"accordion": ""})
		.toggleClass("accordion")
		.find(".ui-panel-content")
            .css("font-family", $QepSettings.FontFamily)
			.end();
	
	
	$dom.each(function(){
		if (!$(this).find(".ui-panel-content").text()){
			$(this).css("display","none");
		}
		else if ($(this).children("div").css("display")=="none") {
			$(this).children("h3").trigger($.browser.click);
		}
	})
	
	return $dom;
}

$.fn.updatePanel = function () {
	var $dom = this;
	
    $dom
        .find(".ui-panel-content-text")
        .html(cnt ? cnt : $.LL("Empty"))
        .show();
		
	return $dom;
}

$.fn.jtabs = function () {
	var $dom = this;
	
	if (!$dom.find("ul").length) {
		$dom.append($("<ul/>"));
	}
	
	var $tabs = $dom.tabs()
		.addClass("ui-tabs-scrollable");
	
	var $cnt = $tabs.find(".ui-tabs-scroll-container");
	if (!$cnt.length) {
		$cnt = $('<div class="ui-tabs-scroll-container"></div>')
			.height("39")
			.prependTo($tabs);
	}

	var $hdr = $tabs.find(".ui-tabs-nav-scrollable");
	if (!$hdr.length) {
		$hdr = $('<div class="ui-tabs-nav-scrollable ui-widget-header ui-corner-all"></div>').appendTo($cnt);
	}
	
	var $nav = $tabs
		.find(".ui-tabs-nav:first")
			.removeClass("ui-widget-header ui-corner-all")
			.appendTo($hdr);

	var $arrNav = $tabs.find(".ui-tabs-nav-arrows");
	if (!$arrNav.length) {
		$arrNav = $('<ol class="ui-helper-reset ui-helper-clearfix ui-tabs-nav-arrows"></ol>')
			.prependTo($tabs);
	}
	
	var $prev = $arrNav.find(".ui-tabs-arrow-previous");
	if (!$prev.length) {
		$prev = $('<li class="ui-tabs-arrow-previous ui-state-default ui-corner-bl ui-corner-tl" title="Previous"><a href="#"><span class="ui-icon ui-icon-carat-1-w">Previous tab</span></a></li>')
			.prependTo($arrNav).hide().css("top", "0.5px");
	}
	var $next = $arrNav.find(".ui-tabs-arrow-next");
	if (!$next.length) {
		$next = $('<li class="ui-tabs-arrow-next ui-state-default ui-corner-tr ui-corner-br" title="Next"><a href="#"><span class="ui-icon ui-icon-carat-1-e">Next tab</span></a></li>')
		.appendTo($arrNav).hide().css("top", "0.5px");
	}

	var scrollTo = function(to, delay) {
		var navWidth = 0,
			arrowWidth = $prev.outerWidth(),
			marginLeft = -(parseInt($nav.css("marginLeft"), 10)),
			hwidth = $hdr.width() - 10,
			newMargin = 0;
		
		$nav.find("li").each(function() {
			navWidth += $(this).outerWidth(true);
		});
		
		if (to instanceof $.Event) {
			
		} else {
			newMargin = marginLeft+to;
			if (newMargin > (navWidth-hwidth)) {
				newMargin = (navWidth-hwidth);
			} else if (newMargin < 0) {
				newMargin = 0;
			}
			$nav.stop(true).animate({
				marginLeft: -(newMargin)
			}, delay, function(){
				$(window).trigger("resize.tabs");
			});
		}
	}

	var holdTimer = false;
	$prev.add($next)
		.on($.browser.click, function(e) {
			var isNext = this === $next[0];
			e.preventDefault();
			if (!holdTimer)
				scrollTo(isNext ? 150 : -150, 250);
		})
		.bind({
			"mousedown": function(e){
				var isNext = this === $next[0],
					duration = 10, pos = 15, timer;
				if (holdTimer)
					clearTimeout(holdTimer);
				holdTimer = setTimeout(timer = function(){
					scrollTo(isNext ? pos : -(pos), duration);
					holdTimer = setTimeout(arguments.callee, duration);
				}, 150);
			},
			"mouseup mouseout": function(e){
				clearTimeout(holdTimer);
				holdTimer = false;
				$nav.stop();
			}
		});

	$(window).bind("resize.tabs", function() {	
		var navWidth = 0;
		var arrowWidth = $prev.outerWidth();		
		$nav.find("li").each(function() {
			navWidth += $(this).outerWidth(true);
		});

		var marginLeft = -(parseInt($nav.css("marginLeft"), 10)),
			hwidth = $hdr.width();
		
		if (parseInt(navWidth) > (hwidth+marginLeft)) {
			$hdr.addClass("ui-tabs-arrow-r");
			$next.show("fade");
			if (marginLeft > 0) {
				$hdr.addClass("ui-tabs-arrow-l");
				$prev.show("fade");
			} else {
				$hdr.removeClass("ui-tabs-arrow-l");
				$prev.hide("fade");
			}
		} 
		else {
			$hdr.removeClass("ui-tabs-arrows ui-tabs-arrow-l");
			$next.hide("fade");
			if (marginLeft > 0) {
				$hdr.addClass("ui-tabs-arrow-l");
				$prev.show("fade");
			} else {
				$hdr.removeClass("ui-tabs-arrow-l");
				$prev.hide("fade");
			}
		}
	}).trigger("resize.tabs");

	$arrNav.find("li").bind({
		"mouseenter focus": function(e) {
			$(this).addClass("ui-state-hover");
		},
		"mouseleave blur": function(e) {
			$(this).removeClass("ui-state-hover");
		}
	});

	$tabs.find("a").bind("click.tabs", function(){
		var li = $(this).parent(),
			arrowWidth = $prev.outerWidth(),
			width = li.outerWidth(true),
			hwidth = $hdr.width(),
			pos = li.position().left,
			marginLeft = -(parseInt($nav.stop(true,true).css("marginLeft"),10)),
			newMargin = -1;

		if (li.index() === 0) {
			newMargin = 0;
		} else if ((pos+width) >= (hwidth+marginLeft)) {
			newMargin = pos-hwidth+width;
			if ((li.index()+1) < $nav.find("li").length) {
				newMargin += arrowWidth;
			}
		} else if (pos < marginLeft) {
			newMargin = pos-arrowWidth;
		}
		
		if (newMargin > -1) {
			$nav.animate({
				marginLeft: -(newMargin)
			}, 250, function(){
				$(window).trigger("resize.tabs");
			});
		}
	});
	
	return $dom;
}

$.fn.adjustTabScroll = function() {
	var $dom = this;
	
	if (!$dom.hasClass("ui-tabs-scrollable")) {
		return $dom;
	}
	
	$(this).each(function(){
		var $tabs = $(this);
		
		if ($tabs.data("flipped") == 1){
			return true;
		}
				
		var $cnt = $tabs
			.find(".ui-tabs-scroll-container");
		var $hdr = $tabs
			.find(".ui-tabs-nav-scrollable");
		var $nav = $tabs
			.find(".ui-tabs-nav:first");
		var $prev = $tabs
			.find(".ui-tabs-arrow-previous");
		var $next = $tabs
			.find(".ui-tabs-arrow-next");
			
		var width = 0;
		
		var li = $tabs.getActiveTab(true).parent();

		if (!li.length) {
			return $(this);
		}

		var arrowWidth = $prev.outerWidth(),
			width = li.outerWidth(true),
			hwidth = $hdr.width(),
			pos = li.position().left,
			marginLeft = -(parseInt($nav.stop(true,true).css("marginLeft"),10)),
			newMargin = -1;
			nwidth = 0;
		
		$nav.find("li").each(function(){
			nwidth += $(this).outerWidth()
			var $img = $(this).find(".loader-small");
			if( $img.length && $img.css("display")!="none" ) {
				nwidth -= 21;
			}
		})
			
		if (li.index() === 0) {
			newMargin = 0;
		} else if ((pos+width) >= (hwidth+marginLeft)) {
			newMargin = pos-hwidth+width;
			if ((li.index()+1) < $nav.children("li").length) {
				newMargin += arrowWidth;
			}
		} else if (pos < marginLeft) {
			newMargin = pos-arrowWidth;
		} else {
			newMargin = Math.max(nwidth - hwidth, 0);
		}
			
		if (newMargin > -1) {
			$nav.stop(true, true).animate({
				marginLeft: -(newMargin)
			}, 250, function(){
				(newMargin <= 0) ? $prev.fadeOut() : $prev.fadeIn();
				(hwidth > (nwidth+arrowWidth)) ? $next.fadeOut() : $next.fadeIn();
			});
		}
	})
	
	return $dom;
}

$.fn.addTab = function () {
    if (!arguments.length) {
        return this;
    }
	
	var $dom = this;
	
	var $opts = {
		title: "tab",
		emptytext: "",
		content: $.noop,
		sequence: -1
	}
		
	if (arguments.length) {
		$.extendSafely($opts, arguments[0]);
	}

	var prefix = "tab-";
	var tabId = $opts.title;
	
	var specialChars = "!@#$^&%*()+=-[]\/{}|:<>?,.";
	for (var i = 0; i < specialChars.length; i++) {
		tabId= tabId
			.replace(/\s+/g, '')
			.replace(new RegExp("\\" + specialChars[i], 'gi'), '');
	};
		
    var $list = $dom.find("ul");

    if (!$list.length) {
        $list = $("<ul/>").appendTo($dom)
        $dom.tabs();
    }

    var $anch = $("<a/>")
        .attr("href", "#" + prefix + tabId)
		.attr("data-sequence", $opts.sequence)
		.html($opts.title)
		.disableSelection();
		
    var $item = $("<li/>").html($anch);
	
    var $tab = $("<div/>")
        .attr("id", prefix + tabId)
        .addClass("tabContent")
        .css({
			"font-family": $QepSettings.FontFamily,
			"font-size": $QepSettings.FontSize
		})
        .appendTo($dom);

    $anch
        .toggleLoaderSmall().find(".loader-small").css({
			"margin-left": "5px",
			"margin-right": 0
		}).end()
        .on($.browser.click, function () {
            if ($list.hasClass("tab-loading")) {
                return false;
            }

            if ($item.hasClass("ui-state-disabled")) {
                return false;
            }

            $anch.css("outline", "none");

			$tab.empty();
			$list.addClass("tab-loading");
			$item.siblings().not($tab).addClass("ui-state-disabled");
			$anch.toggleLoaderSmall();

            $.async(function () {
				$opts.content.call($tab)
            }, 100);

            $.async(function () {
				$list.removeClass("tab-loading");
				$anch
					.css("cursor", "pointer")
					.toggleLoaderSmall(false, function () {
						$item.siblings().not($tab).removeClass("ui-state-disabled");
					});
            }, 250);

            return false;
        });

	if (!$opts.sequence || $opts.sequence==-1) {
		$list.append($item);
	}
	else {
		var $tabs = $list.find("li");
		if (!$tabs.length) {
			$list.append($item);
		}
		else {
			var seq = parseInt($opts.sequence) <= 0 ? $opts.sequence+1  : $opts.sequence-1;
			$tabs.eq(seq).before($item);
		}
	}
		
    $dom.tabs("refresh");

    return $dom;
}

$.fn.activateTab = function () {
	var $dom = this;
	
    var idx = arguments[0] ? arguments[0] : 0;

    $dom
        .tabs("option", "active", idx)
        .find("ul.ui-tabs-nav li").eq(idx)	
			.children("a").trigger($.browser.click);

    return $dom;
}

$.fn.getActiveTab = function () {
	var $dom = this;
	
	var header = false;
	
	if (arguments.length) {
		header = arguments[0];
	}
	
    var $tab = $dom
		.find("li.ui-state-active")
			.children("a:first");
    
	if (header) {
		return $tab;
	}
	
	var $cnt = $($tab.attr("href"));

    return $cnt;
}

$.fn.addButton = function () {
    if (!arguments.length) {
        return $();
    }
    
	var $dom = this
	
    var txt = arguments[0] || "";
    var ico = arguments[1] ? arguments[1] : "";
    var cls = arguments[2] ? arguments[2] : "button";
    var fnc = arguments[3] ? arguments[3] : "";
	
	if (typeof arguments[4] != "undefined") {
		ldr = arguments[4];
	}

    var bid = txt.replace(/ /g, "");

    var $btn = $("<button/>")
        .html(txt)
        .addClass(cls)
        .attr("id", bid)
        .css({
            "margin-left": "0.3em",
            "padding": "0"
        })
        .button({
            text: (txt ? true : false),
            icons: { primary: ico }
        })
        .find(".ui-icon")
            .css({
                "margin-top": "-8px"
            })
        .end()
        .find(".ui-button-text")
            .css({
                "font-size": "0.65em",
                "padding-top": "0.3em",
                "padding-bottom": "0.32em",
                "padding-left": "2.5em",
                "line-height": "1.2em",
				"min-height": "1.2em"
            }).end()
        .appendTo($dom);

    
	if (!ico) {
		$btn.find(".ui-icon").remove();
		$btn.find(".ui-button-text").css("padding-left", "1em");
	}
	else if (ico.match(/template:/i)) {
        	$btn.find(".ui-icon")
			.css("background-image", "url(" + $QisSession.HTMLBase + "/images/templates/" + ico.split(":")[1] + ".png)");
	}
	else if (ico.indexOf(".png") > -1) {
        	$btn.find(".ui-icon")
			.css("background-image", "url(images/controls/" + ico + ")");
	}
	else if (ico.indexOf(".gif") > -1) {
        	$btn.find(".ui-icon")
			.css("background-image", "url(" + ico + ")");
	}
    
	$btn.on($.browser.click, function (e) { 
		switch (typeof fnc) {
			case "function":
				fnc(e); break;
			case "string":
				eval(fnc); break;
			default: break;
		}
	});

    return $btn;
}

$.fn.addDropdownButton = function () {
    if (!arguments.length) {
        return this;
    }
	
	var $dom = this;

    var txt = arguments[0];
    var ico = arguments[1] ? arguments[1] : "";
    var cls = arguments[2] ? arguments[2] : "dropdownbutton";

    var bid = txt.replace(/ /g, "");

    var $btn, $menu, $span, $cont;

    $span = $("<span/>")
        .addClass(cls)
		.css("display", "inline-block")
        .attr("id", bid)
        .appendTo($dom);

    $btn = $("<button/>")
        .html(txt)
        .css({
            "margin-left": "0.3em",
            "padding": "0"
        })
        .button({
            text: (txt ? true : false),
            icons: { primary: ico }
        })
        .find(".ui-icon")
            .css({
                "margin-top": "-8px"
            })
        .end()
        .find(".ui-button-text")
            .css({
                "font-size": "0.65em",
                "padding-top": "0.3em",
                "padding-bottom": "0.32em",
                "padding-left": "2.5em",
                "line-height": "normal",
				"min-height": "1.2em"
            })
        .end()
        .appendTo($span);

	if (!ico) {
		$btn.find(".ui-icon").remove();
		$btn.find(".ui-button-text").css({
			"padding-left": "1em"
		});
	}
	else if (ico.match(/template:/i)) {
		$btn.find(".ui-icon")
			.css("background-image", "url(" + $QisSession.HTMLBase + "/images/templates/" + ico.split(":")[1] + ".png)");
	}
	else if (ico.match(/.png/i)) {
		$btn.find(".ui-icon")
			.css("background-image", "url(images/controls/" + ico + ")");
	}

    $btn = $("<button/>")
        .button({
            text: false,
            icons: { primary: "ui-icon-triangle-1-s" }
        })
        .css({
            "margin-left": "3px",
            "padding": "3px",
            "width": "20px",
			"height": "21.5px"
        })
        .appendTo($span);
	
	$btn.css("height", $btn.prev().css("height") + 1);
	
    $span
		.buttonset()
		.find("button")
			.on($.browser.click, function () {
				var $m = $(this)
					.siblings("ul")
						.toggle();
				
					var $btn = $m.siblings("button");
					var offX = parseInt($btn.first().position().left);
										
					$m.css({
						"left": offX + "px",
						"right": 10 + "px"
					});

				$(document).one($.browser.click, function () {
					$m.hide();
				});
				
				var timeout = 0;
				
				$m.on("mouseleave", function(){
					timeout = $.async(function(){
						$m.fadeOut();
					}, 1000);
				})
				
				$m.on("mouseenter", function(){
					$.async(false, timeout);
				})

				return false;
			});
			
    $menu = $("<ul/>")
        .hide()
        .menu()
		.addClass("ui-corner-all")
        .css({
            "position": "absolute",
            "z-index": "100",
            "font-size": "0.65em",
			"min-width": "170px",
			"max-width": "200px"
        })
        .appendTo($span);

    return $span;
}

$.fn.addDropdownButtonItem = function () {	
    if (!arguments.length) {
        return this;
    }
	
	var $dom = this;

    var $menu = $dom.find("ul");

    var txt = arguments[0];
    var ico = arguments[1] ? arguments[1] : "";
    var fnc = arguments[2] ? arguments[2] : "";
	
    var $cnt = arguments[3] ? arguments[3] : $("span.governanceactions");

	if (typeof arguments[4] != "undefined") {
		ldr = arguments[4];
	}
	
    var $item = $("<li/>")
        .css("margin", ".25em")
        .addClass("ui-corner-all")
        .hover(function () {
            $(this).toggleClass("ui-state-hover");
        }, function () {
            $(this).toggleClass("ui-state-hover");
        });

    var $menuopt = $("<a/>")
        .html(txt)
        .css({
            "margin": "0 1em",
            "display": "block",
            "line-height": "1.8em",
            "padding-left": ico ? "20px" : "5px",
            "cursor": "pointer",
            "font-size": "1.1em"
        })
        .on($.browser.click, function () {
            switch (typeof fnc) {
                case "function":
                    fnc(); break;
                case "string":
                    eval(fnc); break;
                default: break;
            }
            $menu.hide();
            return false;
        })
        .appendTo($item);

	if (ico.match(/template:/i)) {
        	$menuopt.css("background", "url(" + $QisSession.HTMLBase + "/images/templates/" + ico.split(":")[1] + ".png) 0 50% no-repeat");
	}
	if (ico.match(/indicators/i)) {
        	$menuopt.css("background", "url(images/" + ico + ") 0 50% no-repeat ");
	}
	else if (ico.match(/.png/i) && !ico.match(/http:|https:/i)) {
		$menuopt.css("background", "url(images/controls/" + ico + ") 0 50% no-repeat")
	}
	else {
		$menuopt.css("background-image", "url(" + ico + ") 0 50% no-repeat");
	}

    $menu.append($item);

    return $menuopt;
}

$.fn.loadingText = function() {
	var $dom = this;
	
	var word = arguments[0] || "Loading";
	var tag = arguments[1] || "<div/>";
	var speed = arguments[2] || 500;
	var dots = arguments[3] || 3;
	
	$text = $(tag).addClass("loadingtext")
		.Loadingdotdotdot({
			word: word,
			speed: speed,
			maxDots: dots
		})
		.appendTo($dom);

	return $dom;
}

$.fn.isLoading = function() {
	var $dom = this;
	
	if ($dom.hasClass("ajaxloader")) {
		return true;
	}
	else if ($dom.html().match(/ajaxloader/i)){
		return true;
	}
	return false;
}

$.fn.ajaxLoaderText = function() {
	var $dom = this;
	
	var enable = arguments.length ? arguments[0] : true;
	var txt = arguments[1] 
		? arguments[1] 
		: $.LL("Loading") + "...";
	
	var img = true;
	if (typeof arguments[2] !== "undefined") {
		img = arguments[2];
	}
		
	var $loader = $dom.find(".ajaxloader");
	
	if (enable) {
		if ($loader.length) {
			$loader.data("count", $loader.data("count") + 1);
		}
		else {
			$loader = $("<div/>")
				.addClass("ajaxloader")
				.data("count", 1)
				.toggleLoaderSmall(img)
				.append("<span>" + txt + "</span>")
				.appendTo($dom);
		}
	}
	else if ($loader.length) {
		$loader.data("count", $loader.data("count") - 1);
		if ($loader.data("count") < 1) {
			$loader.remove();
		}
	}
	
	return $dom;
}

$.fn.toggleLoaderSmall = function () {
	var $dom = this;
	
	var showImg = false;
	if (typeof arguments[0] !== "undefined") {
		showImg = arguments[0];
	}
	
	var callback = arguments[1] ? arguments[1] : $.noop;
	var $img = $dom.find("span.loader-small");
	
    if (!$img.length) {
        $img = $("<span/>").addClass("loader-small").appendTo($dom);
		
		if (!showImg) {
			$img.hide();
		}
    }
    else {
		var visible = !$img.css("display").match(/none/i);
		if (visible) {
			$img.animate({"opacity":0}, function(){
				$img.hide();
				callback.call($dom);
			});
		}
		else {
			$img.css({"opacity": 0, "display": "inline-block"}).show()
				.animate({"opacity":1}, function(){
					callback.call($dom);
				});
		}
    }
	
    return $dom;
}

$.fn.restrictTextLength = function() {
	var $dom = this;
	
	var maxLength = arguments[0] || Math.round(parseInt($dom.parent().css("width")) / 7.5);

    var curText = $dom.text();
    var lengthToShortenTo = parseInt(maxLength, 10);

    if (curText.length > lengthToShortenTo) {
        $dom.text(curText.substring(0, lengthToShortenTo) + "...");
    }

	return $dom;
}

$.fn.tableOp = function () {
    if (!arguments.length || !this.length) {
        return this;
    }
	
    var $dom = this;
	var $cnt = this;
    var $itm = arguments[0];
	var frmt = arguments[1] || null;
	var sort = arguments[2] || false;
	var islist = String(frmt).match(/list/i);
	var sortorder = null;
	var sortattr = null;
	var exist = false;
	
	if (frmt) {
		frmt = frmt.replace(/list,|,list|list/i, "");
		if (frmt.match(/asc/i)) {
			sortorder = "asc";
		}
		if (frmt.match(/desc/i)) {
			sortorder = "desc";
		}
		frmt = frmt.replace(/asc,|,asc|asc|desc,|,desc|desc/i, "");
		sortattr = frmt;
	}
	
	if (sortorder || sortattr) {
		sort = true;
	}
	
    if (!$itm.length) {
        return $dom;
    }
	
    var validElement = function(){
		var $this = this;
		var oid = $itm.data("objid");
		var cid = $itm.data("confid");
		$this.contents().each(function() {
			if ($(this).data("objid") == oid
			&& $(this).data("confid") == cid) {
				return false;
			}
		});
		return true;
	}
	
	if (!validElement.call($dom)) {
		return $dom;
	}

    if (islist) {
		if (!$dom.is("ul") && !$dom.is("ol")) {
			if ($dom.children("ul").length) {
				$cnt = $dom.children("ul:first")
			}
			else if ($dom.children("ol").length){
				$cnt = $dom.children("ol:first")
			}
			else {
				$cnt = $("<ul/>").addClass("itemlist").appendTo($dom);
			}
		}
		
		if (!$itm.is("li")) {
			$itm = $("<li/>")
				.addClass("item")
				.data($itm.data())
				.html($itm);
		}
    }
		
	if (sort) {
		var reverse = sortorder==="desc";
		var aval = sortattr ? $itm.find("a").data(sortattr) : $itm.text();
		$cnt.children().each(function () {
			var cval = sortattr ? $(this).data(sortattr) : $(this).text();
			if (reverse ? (aval > cval) : (aval < cval)) {
				$itm.insertBefore($(this));
				exist = true;
				return false;
			}
		});
	}

    if (!exist) {
        $cnt.append($itm);
    }
	
	return $dom;
}

$.fn.toList = function () {
    if (!this.length) {
        return this;
    }

    var $dom = this;
	var frmt = arguments[0] || "";
    var type = arguments[1] ? arguments[1] : "ul";
	
	if (!frmt.match(/list/i)) {
		frmt = frmt ? ("list," + frmt) : "list";
	}

    var $list = $("<" + type + "/>")
		.addClass("itemlist")
		.css({
			"padding": 0,
			"margin": 0,
			"list-style-type": "none"
		});
		
    var updateList = function(){
		this.children().each(function () {
			if ($(this).is("ul") || $(this).is("ol")) {
				updateList.call($(this));
			}
			else {
				$list.tableOp($(this), frmt);
			}
		})
	};
	
	updateList.call($dom);
    $dom.html($list);
    return $dom;
}

$.fn.setIcon = function () {
	var $dom = this;
	
    var templ = $dom .data("template");

    if (!templ) {
        $dom.setProps();
		templ = $dom.data("template");
    }

    if (!templ) {
        return $dom;
    }
    
	var bgpos = arguments[0] ? arguments[0] : "0px 0px";
	
    $dom
		.addClass("qlmicon")
        .css({
            "background-image": "url(" + $QisSession.HTMLBase + "/images/templates/" + templ + ".png)",
            "background-position" : bgpos,
            "background-repeat" : "no-repeat",
            "padding-left": "20px",
            "line-height": "16px",
			"display": "inline-block"
        });
		
	return $dom;
}

$.fn.disableHyperLink = function () {
	var $dom = this;
	var showIcon = arguments.length ? arguments[0] : false;
		
	$dom
		.qtip("disable")
		.removeAttr("href")
		.removeAttr("xlink:href")
		.removeAttr("title")
		.removeAttr("xlink:title")
		.addClass("disabled")
		.removeClass(showIcon?"hyperlink":"qlmicon hyperlink")
		.hover(function(){
			$dom.css({
				"text-decoration": "none",
				"cursor": "default",
				"color": "#000"
			})
		}, function(){
			$dom.css({
				"text-decoration": "none",
				"cursor": "default",
				"color": "#000"
			})
		})
		.off($.browser.click);
		
	$dom.on($.browser.click, function (e) {
			e.preventDefault();
			e.stopImmediatePropagation();
		});
		
	return $dom;
}

$.fn.disableSelection = function() {
	var $dom = this;
	return $dom
		.attr('unselectable', 'on')
		.css('user-select', 'none')
		.on('selectstart', false);
}

$.fn.getTargetWindowPosition = function () {
    var $pos = {
		top:0, left:0
	};

    if (!arguments.length) {
        return pos;
    }

    var evt = arguments[0];
	
    var frameW = arguments[1] || 0;
    var frameH = arguments[2] || 0;
	
    var winH = $(window).height() - 2;
    var winW = $(window).width() - 2;
	
	if ($("html").hasClass("responsive-left")) {
		$pos.top = (winH - frameH)/2 + $(document).scrollTop();
		$pos.left = (winW - frameW)/2 + $(document).scrollLeft();
		return $pos;
	}
	
    var coordX = evt.pageX;
    var coordY = evt.pageY;
	
    var $ifrm = $(evt.target).parents(".iframeview") ? $(".iframeview") : $();
		
    if ($ifrm.length) {
        var $pos = $ifrm.position();
        coordX += $pos.left;
        coordY += $pos.top;
    }
	
	coordX -= $(document).scrollLeft();
	coordY -= $(document).scrollTop();
	
    var offsetX = 20;
    var offsetY = 10;
	
	if ($(evt.target).parents("#dataLeft").length) {
		offsetX = $(evt.target).width()/2; 
	}

    if ((coordX + frameW + offsetX) < winW) {
        $pos.left = coordX + offsetX;
    }
    else if ((coordX - frameW - offsetX) > 0) {
        $pos.left = coordX - frameW - offsetX;
    }
    else {
        $pos.left = -1;
    }

    if ((coordY + frameH + offsetY) < winH) {
        $pos.top = coordY + offsetY;
    }
    else if ((coordY - frameH - offsetY) > 0) {
        $pos.top = coordY - frameH - offsetY;
    }
    else {
        $pos.top = -1;
    }
    
    return $pos;
}

$.fn.getTargetWindowSize = function() {
	var $dom = this;
	var $data = arguments[0] ? arguments[0] : $dom.data();
	var $tdef = $.pageCache("get", "def" + $data.objid) || {};
	var target = arguments[1] ? arguments[1] : $tdef["Target"]
		
	if (!target) {
		target = "IFrame";
	}
	
	var $size = {
		width: $QepSettings.Definitions[target].Width,
		height: $QepSettings.Definitions[target].Height
	}
	
	if (!$tdef) {
		return $size;
	}
	
	$size.width = $tdef.Width;
	$size.height = $tdef.Height;
	
    return $size;
}

$.fn.setJumpOnLink = function () {
	if (!arguments.length) {
		return $(this);
	}
	
	var args = arguments;
	var $dom = this;	
	var $data = args[0];
	
	var $obj = new RepositoryObject($dom);
	
	var info = getRepositoryInfo($dom.data("remote") || $obj.Data.RepId);
	if (info.RepId !== $QisSession.RepId) {
		if (info.FollowLinks && info.WebApplication) {
			if (info.Target.match(/blank|self/i)) {
				return $dom.data("target", "_" + info.Target).attr("target", "_" + info.Target);
			}
		}
		else {
			return $dom.data("target", "Excluded");
		}
	}
	
	if (!$obj.TemplateSettings) {
		return $dom
			.data("target", "Excluded")
			.data("initialized", true);
	}
	
	if (!$obj.TemplateDefinition) {
		$obj.TemplateDefinitions(function(){
			$dom.setJumpOnLink.apply($dom, args);
		});
		return $dom;
	}
	
	var $t = $obj.TemplateDefinition;
	
	$dom
		.data("target", $t.Target)
		.data("initialized", true);
	
	var $f = $t.Functions;
	
	if ($f) {
		var onclick = $f.OnObjectClick;
		if (onclick) {
			$dom.data("onobjectclick", onclick);
			return $dom;
		}
	}
	
	var jumpAttrs = [];
	if ($.keyCount($t.SingleLinkJump)) {
		$.each($t.SingleLinkJump, function(key, value){
			jumpAttrs.push(value);
		})
	}
	
	var conditionAttrs = [];
	if ($.keyCount($t.SingleLinkJumpCondition)) {
		$.each($t.SingleLinkJumpCondition, function(key, value){
			conditionAttrs.push(value);
		})
	}
	
	if (jumpAttrs.length) {
		$dom.data("initialized", false);
		$obj.info(conditionAttrs.concat(jumpAttrs), function(){
			var valid = true; 
			$.each(conditionAttrs, function(idx, val){
				if ($obj.attr(val).text()){
					valid = false;
					return false;
				}
			})
			
			var initialized = true;
			
			if (!valid) {
				$dom.data("initialized", initialized);
				return;
			}
						
			$.each(jumpAttrs, function(idx, val){
				var $val = $obj.attr(val); 
				var $lnk = $val.find(".hyperlink").not(".disabled").first();
				if ($lnk.text() || $lnk.length) {
					var $a = $val.find("a"); 
					var attrHref = (typeof $a.attr("xlink:href") != "undefined") ? "xlink:href" : "href";
					var ahref = $a.attr(attrHref);
					
					$dom.off($.browser.click).data("jumponlink", true);
					$dom.on($.browser.click, function(e){
						e.stopImmediatePropagation();
						e.preventDefault();
						$dom.disableTooltip(true);
						
						var qevent = e;
						$obj.init(function() {
							if ($a.data("objid")){
								$.overlay({transparent: true});
								var $jumpobj = new RepositoryObject();
								$jumpobj.merge($a);
								$jumpobj.init(function(){
									$.overlay(false);
									$jumpobj.HyperLink(null, null, null, null, null)
										.openTarget();
								});
							}
							else {
								var target = $obj.attr("DocumentTarget").text() || "new";
								
								if (ahref.indexOf(".")>-1 || ahref.substring(0,2)==="\\\\") {
									if (openDocumentFile(ahref)) {
										return;
									}
								}
								
								if (String(target).match(/new/i)) {
									$a.attr("target", "_blank");
								}
								
								if ($a.attr("target") === "_blank") {
									$a.openDocumentFile(ahref);
								}
								else {
									location.href = ahref;
								}
							}
						})
					});
					return false;
				}
			});
			
			$dom.data("initialized", initialized);
		});
	}
	
	return $dom;
}


$.fn.setProps = function () {
	var $dom = this;
    var href = arguments[0] ? arguments[0] : $dom.attr("href");

	if (!href) {
		href = $dom.attr("xlink:href");
	}
	
    if (!href) {
		return $dom;
	}
	else if (href.indexOf("?")>-1) {
		var oid = getUrlParams("oid", href);
		var tmp = getUrlParams("template", href);
		var rev = getUrlParams("revision", href);
		var lcd = getUrlParams("lc", href) || $QisSession.LangCode;
		var cid = getUrlParams("cid", href) || $QisSession.ConfId;
		var rid = getUrlParams("rid", href) || $QisSession.RepId;
		
		var info = getRepositoryInfo(rid);
		
		var href = $QisSession.HTMLLocation
			+ (oid ? "?oid=" + oid : "")
			+ (rev ? "&revision=" + rev : "");
		
		
		if (lcd && lcd!==$QisSession.DefaultLangCode) {
			href += "&lc=" + lcd;
		}
		
		if (info.FollowLinks && info.RepId!==$QisSession.RepId) {
			if (info.ConfId) {
				href += "&cid=" + info.ConfId;
			}
			
			if (!info.Target.match(/blank|self/i)) {
				href += "&rid=" + rid;
			}
			else {
				href = href.replace(location.pathname, "/" + info.WebApplication + "/");
			}
			
			if (oid!==$dom.data("objid")){
				cid = rid = "";
			}
			
			$dom.data("remote", info.RepId);
		}
		else if (cid!==$QisSession.BaseConfId) {
			href += "&cid=" + cid;
		}

		if (oid && !$dom.data("objid")) {
			$dom.data("objid", oid);
		}
		
		if (tmp && !$dom.data("template")) {
			$dom.data("template", tmp);
		}
		
		if (rev && !$dom.data("revid")) {
			$dom.data("revid", rev);
		}
		
		if (lcd && $dom.data("language")) {
			$dom.data("language", lcd);
		}
		
		if (cid && !$dom.data("confid")) {
			$dom.data("confid", cid);
		}
		
		if (rid && !$dom.data("repid")) {
			$dom.data("repid", rid);
		}
		
		if (typeof $dom.attr("xlink:href") != "undefined") {
			$dom.attr("xlink:href", href);
		} 
		else {
			$dom.attr("href", href);
		}
		
		if (!$dom.data("name")) {
			$dom.data("name", $dom.attr("title") || $.trim($dom.text().replace(/\n|\r/g, " ")));
		}
		
		return $dom.addClass("hyperlink");		
	}
}

$.fn.setTarget = function () { 
	var args = arguments;
	var $dom = this;
	
	var $data = $dom.data() || {};
	var isSvg = typeof $dom.attr("xlink:href") != "undefined" ? true : false;
	var ahref = isSvg ? $dom.attr("xlink:href") : $dom.attr("href");

	var tooltip = true;

	if ($data.initialized) { 
		return $dom;
	}
	
	if (typeof args[0] != "undefined") {
		tooltip = args[0];
	}
	
	var isDgm = args[1] ? true : false;
	
	if ($dom.is("a")
		&& !ahref 
		&& !$data.template 
		&& !$data.objid) {
	        return $dom;
   	 }
	
	if (!$data.template || !$data.objid || isDgm) {
		$dom.setProps(ahref);
		$.extend(true, $data, $dom.data());
		ahref = $dom.attr(isSvg ? "xlink:href" : "href");
	}
	
	if (typeof ahref == "undefined" || ahref == "#" || $data.qsrc 
	|| typeof  $dom.attr("qsrc") !== "undefined") {
		ahref = $QisSession.HTMLLocation
		     + "?oid=" + $data.objid 
		
		var lcode = ($data.language != $QisSession.DefaultLangCode) 
			? $data.language
			: $QisSession.LangCode
		if (lcode && lcode != $QisSession.DefaultLangCode) {
			ahref += "&lc=" + lcode;
			$dom.data("language", lcode);
		}
		
		var confid = $data.confid || $QisSession.ConfId;
		if (confid && confid != $QisSession.BaseConfId) {
			ahref += "&cid=" + confid;
			$dom.data("confid", confid);
		}
		
		var repid = $data.repid || $QisSession.RepId;
		if (repid && repid != $QisSession.RepId) {
			ahref += "&rid=" + repid;
			$dom.data("repid", repid);
		}
        		
		$dom.attr(isSvg ? "xlink:href" : "href", ahref);
	}

	if (!$data.objid) {
		return $dom;
	}
	
	var $obj = new RepositoryObject($dom);
	if (!$obj.TemplateDefinition) {
		$obj.TemplateDefinitions(function(){
			args[1] = false;
			$dom.setTarget.apply($dom, args);
		});
		return $dom;
	}
	
	if (!$dom.attr("title")) {
		$dom.attr("title", $dom.data("name") || $.trim($dom.text()));
   	}	
	
	$dom.setJumpOnLink($data)
	
	var target = $dom.data("target") || $dom.attr("target");

	if (target.match(/excluded/i)) {
        $dom.disableHyperLink(true);
		return $dom;
   	}
	else if (!$dom.data("jumponlink")) {
		var interval = 0;
		$dom.off($.browser.click);
		$dom.on($.browser.click, function (e) {
			e.preventDefault();
						
			var qevent = e;
						
			if ($dom.data("onobjectclick")) {
				$dom.data("onobjectclick").call((new RepositoryObject($dom)));
				return false;
			}
			
			if ($dom.data("initialized") === false) {
				$.overlay({loader: true});
				$.async(function(){
					if ($dom.data("initialized") === true) {
						$.overlay(false);
					}
					$dom.trigger($.browser.click);
				}, 100);
			}
			else {
				$dom.openTarget(qevent);
			}
			
			return false;
		})
	}
		
	if (tooltip) {
		var delay = -1;
		var title = $dom.attr("title");
		$dom.removeAttr("title").data("title", title);
		$dom.on("mousemove", function(e) {
			$.async(false, delay);
			delay = $.async(function() {
				if ($dom.qtip("api")) {
					return;
				}
				$dom.setTooltip(e, true)
			}, 300);
		}).on("mouseleave", function() {
			$.async(false, delay);
		}).bind($.browser.click, function(){
			$.async(false, delay);
			if ($dom.data("hasqtip")) {
				$dom.disableTooltip(false);
			}
		});
	}
	else {
		$dom.removeAttr("title");
	}
	
    return $dom;
}

$.fn.openTarget = function(e) {
	var $dom = this;
	
	var ahref = $dom.attr("xlink:href") || $dom.attr("href");
	var $data = $dom.data();
	var target = $data["target"] || $dom.attr("target");
	
	if (typeof e == "undefined") {
		e = window.event
	}
	
	var $defs = $.pageCache("get", "def" + $data.objid) || $.browserCache("get", "def" + $data.objid);
	
	if (!$defs) {
		$.overlay({loader: true});
		var $obj = new RepositoryObject($dom);
		$obj.TemplateDefinitions(function(){
			$.overlay(false, true);
			$dom.openTarget.call($dom, e);
		});
		return $dom;
	}

	$dom.disableTooltip(true);
	
	switch (target) {
		case "IFrame":
			if ($("html").hasClass("responsive-left")) {
				$dom.fancyboxwindow(e, $data, target);
			}
			else {
				$dom.iframewindow(e, $data, target);
			}
			break;
			
		case "FancyBox": 
			$dom.fancyboxwindow(e, $data, target);
			break;
		
		default: 
			ahref = ahref ? ahref : $dom.attr("href");
			ahref = ahref.substring(0,1) == "?" 
				? $QisSession.HTMLLocation + ahref
				: ahref.substring(0,2) == "./" 
					? ahref.replace("./", $QisSession.HTMLLocation)
					: ahref;
			
			$.browserCache("set", "def" + $data.objid, $.pageCache("get", "def" + $data.objid));
			
			if (target.indexOf("blank") >-1 || target.indexOf("new") >-1) {
				window.open(ahref);
			}
			else {				
				if (History.enabled) {
					$.overlay(false);
					$dom.instantClick(ahref);
				}
				else {
					$.xhrPool.abortAll();
					window.location.href = ahref;
				}
			}
			break;
	}
	
	return $dom;
}

$.fn.svgZoom = function () {
    if (!arguments.length) {
        return this;
    }
	
	var $dom = this;
	
	var zoomDir = arguments[0];
	var zoomSpd = arguments.length>1 ? arguments[1] : 50;
	var zoomFac = arguments.length>2 ? arguments[2] : 1;
	var zoomAnm = "linear";
		
    var $svg = $dom.find("svg:first").stop();
	
	if (!$svg.length) {
		return $dom;
	}

    if (!$svg.data("minscale")) {
        $svg.data("minscale", $svg.width() / 4);
    }

    if (!$svg.data("maxscale")) {
        $svg.data("maxscale", $svg.width() * 3);
    }

    var delta = zoomDir > 0 ? 1.03+zoomFac/1000 : 0.97-zoomFac/1000;

	var w = $svg.width() * delta;
	var h = $svg.height() * delta;
	
	if (zoomDir === 100) {
		w = $svg.attr("width");
		h = $svg.attr("height");
		zoomFac = 750;
		zoomAnm = "easeOutCubic";
	}
	else if (zoomDir === -100) {
		var $parent = $svg.parent(".graphicalData").parent();

		var rtX = $svg.attr("width") / $parent.width();
		var rtY = $svg.attr("height") / $parent.height();
		var ratio = rtX > rtY ? rtX : rtY;

		if (ratio < 1) {
			ratio = 1;
		}
		
		w = $svg.attr("width")/ratio;
		h = $svg.attr("height")/ratio;
		zoomFac = 750;
		zoomAnm = "easeOutCubic";
	}
	else {
		if (arguments[0] > 0 && $svg.width() + 5 > $svg.data("maxscale")) {
			return $dom;
		}

		if (arguments[0] < 0 && $svg.width() - 5 < $svg.data("minscale")) {
			return $dom;
		}
	}
	
    $svg.animate({
		width: w,
		height: h
	},
	{
		duration: zoomSpd+zoomFac,
		easing: zoomAnm,
		complete: function() {
			if ($dom.data("zoomactive")){
				$dom.svgZoom(zoomDir, zoomSpd, zoomFac+50);
				return;
			}
				
			$.async(function(){
				var offset = 10;
				var overflow = ($svg.height() > ($dom.height()+offset)  || $svg.width() > ($dom.width()+offset));
				var kinetic = $dom.data("kinetic");

				if (overflow && !kinetic) {
					$dom.kinetic().kinetic("attach").data("kinetic", true);
				}
				else if (overflow && kinetic) {
					$dom.kinetic("attach");
				}
				else if (!overflow && kinetic) {
					$dom.kinetic("detach").data("kinetic", false);
				}
			});
		}
	});
	
	return $dom;
}

$.fn.openDocumentFile = function() {
	var $dom = this;
	
	var src = arguments[0] || $link.attr("href");
	var binary = src.match(/binarydatacontroller.aspx/);
	
	$.overlay({loader:true, transparent:true});
	
	if (!binary) {
		$.async(function(){
			try {
				window.open(src);
			}
			catch (e) {	}
			$.overlay(false);
		}, 1000);
		return $dom;
	}
	
	var $iframe = $("iframe.filelink");
	
	if (!$iframe.length) {
		$("<iframe/>")
			.attr("src", src)
			.addClass("filelink")
			.css({
				"position": "absolute",
				"top": 0,
				"left": -100,
				"height":1,
				"width": 1
			})
			.load(function(){
				$.overlay(false);
				if ($(this).contents().text()) {
					if ($(this).contents().find("[id*=messageLabel]").text()) {
						var $div = $("<div/>").width(500).height(120);
						$div.append("<h1>" + $.LL("The system cannot find the file specified") + "</h1>")
							.append("<br/><div>" + $.LL("Unfortunately the file is permanently removed or deleted from the system, the item can no longer be downloaded.") + "</div>");
						$.fancybox($div);
						return false;
					}
				}
			})
			.appendTo("body");
	}
	else {
		$iframe.attr("src", src);
	}
	
	return $dom;
}

$.fn.svgMapControl = function () {
	var $dom = this;
	
	if ($dom.find("div.map-control").length) {
		return $dom;
	}
	
	var $mapcntrl = $("<div class=\"map-control\" />")
		.addClass("ui-corner-all")
		.append("<a class=\"left\"></a>")
		.append("<a class=\"right\"></a>")
		.append("<a class=\"up\"></a>")
		.append("<a class=\"down\"></a>")
		.append("<a class=\"zoomin\"></a>")
		.append("<a class=\"zoomout\"></a>")
		.append("<a class=\"zoomfull\"></a>")
		.append("<a class=\"zoomfit\"></a>");

    var interval = 5;
    var timer = 0;

    $('.left', $mapcntrl)
		.attr("title", $.LL("Scroll left"))
        .on("mousedown touchstart", function (e) {
            if ($dom.data("kinetic")) {
                timer = $.async(function () {
                    $dom.kinetic('start', { velocity: -15 });
                }, interval, true);
            }
            return false;
        })
        .on("mouseup mouseout touchend", function (e) {
            if ($dom.data("kinetic")) {
                $.async(false, timer);
                $dom.kinetic('end');
            }
            return false;
        });
    $('.right', $mapcntrl)
		.attr("title", $.LL("Scroll right"))
        .on("mousedown touchstart", function (e) {
            if ($dom.data("kinetic")) {
                timer = $.async(function () {
                    $dom.kinetic('start', { velocity: 15 });
                }, interval, true);
            }
            return false;
        })
        .on("mouseup mouseout touchend", function (e) {
            if ($dom.data("kinetic")) {
                $.async(false, timer);
                $dom.kinetic('end');
            }
            return false;
        });
    $('.up', $mapcntrl)
		.attr("title", $.LL("Scroll up"))
        .on("mousedown touchstart", function (e) {
            if ($dom.data("kinetic")) {
                timer = $.async(function () {
                    $dom.kinetic('start', { velocityY: -15 });
                }, interval);
            }
            return false;
        })
        .on("mouseup mouseout touchend", function (e) {
            if ($dom.data("kinetic")) {
                $.async(false, timer);
                $dom.kinetic('end');
            }
            return false;
        });
    $('.down', $mapcntrl)
		.attr("title", $.LL("Scroll down"))
        .on("mousedown touchstart", function (e) {
            if ($dom.data("kinetic")) {
                timer = $.async(function () {
                    $dom.kinetic('start', { velocityY: 15 });
                }, interval, true);
            }
            return false;
        })
        .on("mouseup mouseout touchend", function (e) {
            if ($dom.data("kinetic")) {
                $.async(false, timer);
                $dom.kinetic('end');
            }
            return false;
        });
    $('.zoomin', $mapcntrl)
		.attr("title", $.LL("Zoom in"))
        .on("mousedown touchstart", function (e) {
			$dom.data("zoomactive", 1);
			$dom.svgZoom(1);
            return false;
        })
        .on("mouseup mouseout touchend", function (e) {
			$dom.data("zoomactive", 0);
            return false;
        });
    $('.zoomout', $mapcntrl)
		.attr("title", $.LL("Zoom out"))
        .on("mousedown touchstart", function (e) {
			$dom.data("zoomactive", 1);
			$dom.svgZoom(-1);
            return false;
        })
        .on("mouseup mouseout touchend", function (e) {
			$dom.data("zoomactive", 0);
            return false;
        });
		
    $('.zoomfull', $mapcntrl)
		.attr("title", $.LL("Zoom 100%"))
        .on("mousedown touchstart", function (e) {
			$dom.svgZoom(100);
            return false;
        });
		
    $('.zoomfit', $mapcntrl)
		.attr("title", $.LL("Zoom fit-to-window"))
        .on("mousedown touchstart", function (e) {
			$dom.svgZoom(-100);
            return false;
        });
		
	return $dom.append($mapcntrl);
}

$.fn.validMenuItems = function() {
	var $dom = this;	
	
	$dom.find("a").each(function(){
		var role = $(this).data("role");
		if (!isValidRole(role)){
			$(this).parent("li").empty().remove();
		}
	});
	
	return $dom;
}

$.fn.adjustMenu = function () {
	var $dom = this;
	
    $dom.css({
        "left": $("#logo").width() + "px",
        "width": $("#header").width() - $("#logo").width() + "px",
		"margin-top": $("#header").css("margin-top")
    });

    var $menu = $dom.find("#mega-menu");

    if (!$menu.length) {
        return $dom;
    }

    var menuWidth = $menu.width() - 5;

    var scaleF = 0.002;
    var childW = $menu.children("li:first").width();
    var childP = $menu.width() * scaleF;

    childP = Math.max(childP, 1);

    var offSet = Math.max((childP - 1) * 10, 1);
    offSet = Math.max(offSet, 0);

    var $itemList = $menu.children("li").hide().attr("hidden", "hidden");

    $itemList.children("a").css({
        "padding-left": Math.max(childP, 1.75) + "em",
        "padding-right": childP + "em"
    })
    .children(".dc-mega-icon").css({
        "right": offSet + "px"
    })

    $menu.siblings("span").hide();
	
    var $item = $itemList.first();

    menuWidth -= $item.outerWidth();

    do {
        $item.show().removeAttr("hidden");
        $item = $item.next("li");
        menuWidth -= $item.outerWidth();
    }
    while ($item.length && menuWidth >= 0)

    if ($itemList.last().attr("hidden")) {
        $menu.nextAll("span:first").show();
    }

    return $dom;
}

$.fn.adjustSubMenu = function () {
	var $dom = this;
	
	if (!$dom.parent().length) {
		return $dom;
	}
	
	var $MegaMenuSettings = arguments[0];
	var offsetY = arguments[1];
	
	$dom.css({
			"top": offsetY - 1 + "px"
		})
		.hover(function () {
			$(this).prev("a").addMenuHoverStyle($MegaMenuSettings);
		}, function () {
			$(this).prev("a").addMenuStyle($MegaMenuSettings);
		});
	
	$.async(function(){
		if ($dom.data("initialized")) {
			return;
		}
		
		$dom.find("a.mega-hdr-a").each(function () {
			$(this)
				.addMenuHyperLink()
				.addMenuStyle($MegaMenuSettings.SubMenu.Header)
				.addClass("text-shadow")
				.hover(function () {
					$(this).addMenuHoverStyle($MegaMenuSettings.SubMenu.Header);
				}, function () {
					$(this).addMenuStyle($MegaMenuSettings.SubMenu.Header);
				})
				.next("ul").find("a").each(function () {
					$(this)
						.addMenuHyperLink()
						.addMenuStyle($MegaMenuSettings.SubMenu.Item)
						.hover(function () {
							$(this).addMenuHoverStyle($MegaMenuSettings.SubMenu.Item);
						}, function () {
							$(this).addMenuStyle($MegaMenuSettings.SubMenu.Item);
						});
				});
		});
		
		$dom.data("initialized", true);
	}, 50);
	
    var $item = $dom.parent();
    var $menu = $item.parent();

    var subW = $dom.outerWidth();
    var relW = subW / 2 - $item.outerWidth() / 2;
    var posL = $item.position()["left"];
    var limM = $menu.parent().width();

    posL = (posL > 0) ? posL : 0;
    $dom.css("left", posL + "px");

    var mrgL = (((posL - relW) > 0) ? -relW : -posL);
    $dom.css("margin-left", mrgL + "px");

    var diff = (posL + mrgL + subW) - limM;
    if (diff > 0) {
        $dom.css("margin-left", mrgL - diff + "px");
    }
	
	return $dom;
}

$.fn.adjustMenuNavigation = function () {
	var $dom = this;
	
    var navLeft = $dom.attr("rel") == "nav-prev";

    var barP = $("#bar").outerHeight() - $("#bar").height()
    var btnH = $("#bar").height();
    var btnT = $("#header").outerHeight();

    $dom
        .button({
            icons: { primary: "ui-icon-carat-1-" + (navLeft ? "w" : "e") },
            text: false
        })
        .css({
            "position": "absolute",
            "left": navLeft ? "0" : "",
            "right": !navLeft ? "0" : "",
            "top": btnT + barP / 2 - 2 + "px",
            "height": btnH + 2 + "px",
            "width": "16px",
            "z-index": "101"
        })
		.removeClass("ui-corner-all")
		.addClass(navLeft ? "ui-corner-left" : "ui-corner-right")
        .on($.browser.click, function (e) {
            $(this).scrollMenu(e);
            return false;
        })
		.find(".ui-icon").css("margin-top", "-9px");

    return $dom;
}

$.fn.scrollMenu = function () {
	var $dom = this;
	
    var leftNav = $dom.attr("rel") == "nav-prev";

    var $menu, $left, $right;

    if (leftNav){
		$left = $dom;
		$menu = $dom.nextAll("ul:first");
		$right = $menu.nextAll("span:first");
	}
	else {
		$right = $dom;
		$menu = $dom.prevAll("ul:last");
		$left = $menu.prevAll("span:last");
	}

    var $scrollList = $menu.children("li[hidden!='hidden']");
    var scrollWidth = $menu.width();

    $scrollList
        .fadeOut(250, function () {
            $scrollList.attr("hidden", "hidden");

            var $item = leftNav ? $scrollList.first().prev("li") : $scrollList.last().next("li");

            scrollWidth -= $item.outerWidth();

            do {
                $item.fadeIn().removeAttr("hidden");
                $item = leftNav ? $item.prev("li") : $item.next("li");
                scrollWidth -= $item.outerWidth();
            }
            while ($item.length && scrollWidth >= 0)


            $menu.children("li:last").attr("hidden") ? $right.show() : $right.hide();
            $menu.children("li:first").attr("hidden") ? $left.show() : $left.hide();
        });
}

$.fn.addMenuStyle = function () {
    if (!arguments.length) {
        return this;
    }

	var $dom = this;
    var $style = arguments[0];
	var isdisabled = $dom.hasClass("disabled");
	
    $dom.css({
        "font-family": $style.FontFamily,
        "font-weight": $style.FontStyle,
        "font-size": $style.FontSize,
        "color": $style.Color,
        "text-decoration": isdisabled?"none":$style.TextDec,
	"background-color": $style.BgColor,
	"background-image": isdisabled?"none":"",
	"height": "auto"
    })
	
	if ($dom.parents(".sub").length){
		$dom.css("text-shadow","none");
	}

    return $dom;
}

$.fn.addMenuHoverStyle = function () {
    if (!arguments.length) {
        return this;
    }
	
	var $dom = this;
    var $style = arguments[0];
	var isdisabled = $dom.hasClass("disabled");
	
    $dom.css({
        "color": isdisabled?$style.Color:$style.ColorH,
        "text-decoration": isdisabled?"none":$style.TextDecH,
        "background-color": isdisabled?$style.BgColor:$style.BgColorH
    })

    return $dom;
}

$.fn.addMenuHyperLink = function () {
	var $dom = this;

	var oid = $dom.data("objid");
	var url = $dom.attr("href");
	
    if (!oid && url=="#") {
        $dom.disableHyperLink();
    }
    else if (oid) {
		$dom.setTarget(false, true);
	}
	else if (url) {
		if (url.toLowerCase().indexOf(location.host.toLowerCase())<0) {
			$dom.attr("target", "_blank");
		}
	}
	
	if (History.enabled) {
		$dom.bind($.browser.click, function() {
			var $parent = $dom.parents(".dc-mega-li");
			if ($parent.length) {
				$parent.triggerHandler("mouseout");
				$parent.children("a").css("text-decoration", "none");
			}
		});
	}

    return $dom;
}

$.fn.addMenuTooltip = function () {
	var $dom = this;
	
	var oid = $dom.data("qtip");
	
	if (oid) {
		var $obj = new RepositoryObject(oid);
		
		$obj.init(function(){
			var desc = $obj.attr("Description").css("padding", "2px 0");	
			if (!desc.text()) {
				return;
			}
			
			$dom.qtip({ 
				content: { text: desc },
				style: { classes: 'qtip-light qtip-shadow qtip-rounded'	},
				position: {
					adjust: { x: -25, y: -12 }
				}
			});
		});
	}
	
	return $dom;
}


$.fn.setGovernanceTaskTooltip = function () {
	if (arguments.length<1){
		return this;
	}
	
	var $dom = this;
	var $task = arguments[0];
	
	if (!$task) {
		return $dom;
	}
	
	var $cnt = $("<div/>");
	
	//.qtip('option', 'content.text', $cnt);
	
	return $dom;
}

//TODO: UAM
$.fn.setGovernanceTaskIndicator = function () {
	if (!arguments.length) {
		return this;
	}
	
	var $dom = this;
	var $task = arguments[0];
	
	if (!$task) {
		return $dom;
	}
	
	if (!$task.InstantiationLevel.match("status").length) {
		 return $task.status(function(){
			 $dom.setGovernanceTaskIndicator($task);
		 });
	}
	
    var date = new Date()
	var warning = $task.Date($task.Data.GovernanceWarningDate, null, null, true);
	var deadline = $task.Date($task.Data.GovernanceLimitDate, null, null, true);

	var status = $QepSettings.Definitions.Governance.GovernanceTaskPending;
    if (deadline < date) {
        status = $QepSettings.Definitions.Governance.GovernanceTaskDelayed;
    }
    else if (warning < date) {
        status = $QepSettings.Definitions.Governance.GovernanceTaskCritical;
    }

    var $indicator = $("<img />")
        .addClass("taskindicator")
        .attr("src", "images/indicators/" + status + ".png")
        .attr("border", 0)
        .css({
            "height": "16px",
            "width": "16px",
			"line-height": "18px",
            "float": "right"
        })

    $dom
        .css({
			"display": "block",
			"margin": "2px 0 2px 0"
		})
        .append($indicator)

    return $dom;
}

$.fn.formatText = function(){
	var $dom = this;
	
	var url1 = /(^|&lt;|\s)(www\..+?\..+?)(\s|&gt;|$)/g,
		url2 = /(^|&lt;|\s)(((https?|ftp):\/\/|mailto:).+?)(\s|&gt;|$)/g,

	convertTextualLinks = function () {
		var childNodes = this.childNodes,
		i = childNodes.length;
		while(i--) {
			var n = childNodes[i];
			if (n.nodeType == 3) {
				var html = n.nodeValue;
				if (html) {
					html = html
						.replace(url1, '$1<a href="http://$2" target="_blank">$2</a>$3')
						.replace(url2, '$1<a href="$2" target="_blank">$2</a>$5');
						
					if (/mailto:/i.test(html) && /\?/i.test(html)) {
						var ref = String(html.split(">")[1]).split("<")[0];
						ref = ref.substring(7, ref.indexOf("?"));						
						html = $(html).text(ref).get(0).outerHTML;
					}
					
					$(n).after(html).remove();
				}
			}
		}
	};

	$dom.each(convertTextualLinks);
	
	$dom.find("*").each(function(){
		if (String($(this).css("font-family")).match(/arial unicode ms/i) > -1) {
			$(this).css("font-family", $QepSettings.FontFamily);
		}
		
		if ($(this).hasClass("tab")) {
			var $parent = $(this).parent(); 
			if ($parent.text().substring(0,1)=="l") {
				$parent.html($parent.html().replace("l", "&bull;"))
			}
		}
		
		if ($(this).is("table") && $(this).attr("qlmstyle") !== "undefined") {
			$(this).addClass("qlm");
		}
		else if ($(this).is("a")) {
			if (typeof $(this).attr("revision") != "undefined" || $(this).data("objid")) {
				$(this).setTarget();
			}
			$(this)
				.addClass("hyperlink textlink")
				.setTooltip();
		}
		else if ($(this).is("ul")) {
			$(this).css({
				"margin-top": 0, 
				"margin-bottom": 0
			});
		}
		else if ($(this).is("img")) {
			var $img = $(this).removeAttr("align").hide();
			var uuid = $img.uniqueId().attr("id");
			var src = $(this).attr("src") || "";
			var typ = "";
			
			if (src.match(/binarydatacontroller.aspx/i)) {
				src = $QisSession.HTMLBase + "/" + src
				typ = getUrlParams("type", src);
				$(this).attr("src", src);
			}
			
			if (typ.match(/diagramlink/i)) {
				var oid = getUrlParams("dataid", src);
				if (oid) {
					var $obj = new RepositoryObject(oid);
					var $cnt = $(this).parents("p").first().wrap("<div class=\"diagramlink\"></div>")
						.parent().empty().ajaxLoaderText();
						
					$obj.audit(function(){
						var style = {};
						if ($.inArray($obj.Data.Template, ["GenericQuery", "Matrix", "ProductRuleTable", "RuleFamilyTable"])>-1) {
							style = {width: null, height: null, datatable: false};
						}
						else {
							style = {animation: false, imagemap: false, view: true};
						}
						$cnt.ajaxLoaderText(false)
							.initContent({0: {Attribute: "HTMLDrawing", Style: style}}, $obj)
							.css("overflow", "visible");	
					});
				}
			}			
			else  {
				$.async(function(){				
					var $img = $("img#"+uuid);
					var width = $img.parent().findContainerSize("width");
					if (width === "100%" || !width) {
						$img.show();
						return;
					}
					
					var imgwidth = $img.attr("width");				
					var imgheight = $img.attr("height");
					var ratio = Math.min(width/imgwidth, 1);

					$img.css({
							"max-width": imgwidth*ratio,
							"max-height": imgheight*ratio,
							"cursor": "pointer"
						}).show().on("click", function(){
							$.fancybox($("<img/>").attr("src", $img.attr("src")));
						});
				});
			}
		}
	});
	
	return $dom;
}

$.fn.fancyboxwindow = function (event) {
	var $dom = this;
	var e = arguments[0] ? arguments[0] : window.event;
	var $data = arguments[1] ? arguments[1] : null
	var target = arguments[2] ? arguments[2] : null;
	
	$.window.closeAll();
	$.fancybox.close();

	var $size = $(this).getTargetWindowSize($data, target);
	
	var $cnt = $("<div/>")
		.addClass("fancyboxwindow popupwindow")
		.width($size.width)
		.height($size.height);
	
	$.fancybox($cnt, {
		scrolling: "no",
		afterShow: function() {
			$.isAFunction("onFancyBoxShow") ? 
				onFancyBoxShow({Container: $cnt, Data: $data}, $dom) : 
				"";
		},
		afterClose: function() {
			$.isAFunction("onFancyBoxClose") ? 
				onFancyBoxClose({Container: $cnt, Data: $data}, $dom) : 
				"";
		}
	});
	
	return $dom;
} 

$.fn.iframewindow = function () {
	var $dom = this;
	var event = arguments[0] ? arguments[0] : window.event;
	var $data = arguments[1] ? arguments[1] : null
	var target = arguments[2] ? arguments[2] : null;
	
	$.fancybox.close();
	
	var $siz = $dom.getTargetWindowSize($data, target);
	var $pos = $dom.getTargetWindowPosition(event, $siz.width, $siz.height);
	
	var $opts = {
		width: $siz.width,
		height: $siz.height,
		showFooter: false,
		bookmarkable: false,
		x: 0,
		y: 0,
		z: 1001,
		checkBoundary: false,
		containerClass: "popupwindow ui-corner-all",
		headerClass: "popupheader",
		footerClass: "popupfooter",
		onIframeStart: function (wnd, url) {  // a callback function while iframe ready to connect remoting url. this attribute only works while url attribute is given
			$.isAFunction("onIFrameStart") ? onIFrameStart(wnd, url) : "";
		},
		onIframeEnd: function (wnd, url) {  // a callback function while iframe load finished. this attribute only works while url attribute is given
			$.isAFunction("onIFrameEnd") ? onIFrameEnd(wnd, url) : "";
		},
		onOpen: function (wnd) {  // a callback function while container is added into body
			$.isAFunction("onIFrameOpen") ? onIFrameOpen(wnd) : "";
		},
		onShow: function (wnd) {  // a callback function while whole window display routine is finished
			$.isAFunction("onIFrameShow") ? onIFrameShow({Container: wnd, Data: $data}, $dom, $pos) : "";
		},
		onClose: function (wnd) { // a callback function while user click close button
			$.isAFunction("onIFrameClose") ? onIFrameClose({Container: wnd, Data: $data}, $dom) : "";
		},
		onSelect: function (wnd) { //  a callback function while user select the window
			$.isAFunction("onIFrameSelect") ? onIFrameSelect(wnd) : "";
		},
		onUnselect: function (wnd) { // a callback function while window unselected
			$.isAFunction("onIFrameUnselect") ? onIFrameUnselect(wnd) : "";
		},
		onDrag: function (wnd) { // a callback function while window is going to drag
			$.isAFunction("onIFrameDrag") ? onIFrameDrag(wnd) : "";
		},
		afterDrag: function (wnd) { // a callback function after window dragged
			$.isAFunction("onIFrameAfterDrag") ? onIFrameAfterDrag(wnd) : "";
		},
		onResize: function (wnd) { // a callback function while window is going to resize
			$.isAFunction("onIFrameResizeStart") ? onIFrameResizeStart(wnd) : "";
		},
		afterResize: function (wnd) { // a callback function after window resized
			$.isAFunction("onIFrameResizeEnd") ? onIFrameResizeEnd(wnd) : "";
		}, 
		onMinimize: function (wnd) { // a callback function while window is going to minimize
			$.isAFunction("onIFrameMinimize") ? onIFrameMinimize(wnd) : "";
		},
		afterMinimize: function (wnd) { // a callback function after window minimized
			$.isAFunction("onIFrameAfterMinimize") ? onIFrameAfterMinimize(wnd) : "";
		},
		onMaximize: function (wnd) { // a callback function while window is going to maximize
			$.isAFunction("onIFrameMaximize") ? onIFrameMaximize(wnd) : "";
		},
		afterMaximize: function (wnd) { // a callback function after window maximized
			$.isAFunction("onIFrameAfterMaximize") ? onIFrameAfterMaximize(wnd) : "";
		},
		onCascade: function (wnd) { // a callback function while window is going to cascade
			$.isAFunction("onIFrameCascade") ? onIFrameCascade(wnd) : "";
		},
		afterCascade: function (wnd) { // a callback function after window cascaded
			$.isAFunction("onIFrameAfterCascade") ? onIFrameAfterCascade(wnd) : "";
		}
	}
	
	if (arguments.length) {
		$opts = $.extendSafely($opts, arguments[0]);
	}
	
	var $wnd = null;
	var $wndlist = parent.$.window.getAll();
	
	if ($QepSettings.Definitions.IFrame.Multiple) {
		$.each($wndlist, function(){
			if (this.getFrame().data("objid") === $data.objid) {
				$wnd = this;
				return false;
			}
		});
	}
	else {
		if ($(".popupwindow").length) {
			$wnd = $wndlist[0];
		}
		else {
			parent.$.window.closeAll();
		}
	}
	
	var $cnt = $("html").hasClass("responsive-left") ? $("body") : $("#dataCenter");
	
	if (!$cnt.length) {
		$cnt = $("body");
	}
	
	if (!$wnd) {
		$wnd = $cnt.window($opts);
		$.window.prepare({
		   dock: 'bottom', // change the dock direction: 'left', 'right', 'top', 'bottom'
		   dockArea: $cnt, // set the dock area
		   minWinLong: 250 // set minimized window long dimension width in pixel
		});
	}
	else {
		$wnd.move($pos.left, $pos.top);
		if ($wnd.isMinimized()) {
			$wnd.restore();
		}
		$wnd.resize($siz.width, $siz.height);
		onIFrameShow({Container: $wnd, Data: $data}, $dom, $pos);
	}
	
	return $dom;
}

$.fn.tooltipContent = function() {
	if (!arguments.length) {
		return this;
	}
	
	var $div = this;
	var $cnt = $div.children().first();

	var args = arguments;	
	var $dom = args[0];
	var evt = args[1];
	var api = args[2];
	
	var orgEvt = args[3] || null;

	var $repObj = new RepositoryObject($dom);
	
	var adjustTooltip = function(){
		var $tip = $(api.elements.target[0]);
		var e = evt.originalEvent;
		
		if (!e.pageX) {
			if (orgEvt) {
				e.pageX = orgEvt.pageX;
			}
			else {
				e.pageX = $(e.target).position().left + 5;
			}
		}
		
		if (!e.pageY) {
			if (orgEvt) {
				e.pageY = orgEvt.pageY;
			}
			else {
				e.pageY = $(e.target).position().top + 5;
			}
		}
		
		var offsetX = 400;
		var offsetY = 350;
		
		var dx = 10;
		var dy = -5;
		
		var $iframe = $dom.parents(".iframeview") ? $(".iframeview").first() : $();
		if ($iframe.length) {
		  var $pos = $iframe.position();
		  dx += $pos.left;
		  dy += $pos.top;
		  
		  var $tabs = $iframe.parents(".tabs");
		  if ($tabs.length) {
			$pos = $tabs.first().position();
			dx += $pos.left;
			dy += $pos.top;
		  }
		}
		
		var pageX = e.pageX + dx;
		var pageY = e.pageY + dy;
		
		var my = ["bottom", "left"];
		var at = ["top", "right"];
		
		if ( (pageX + offsetX) > $(window).innerWidth() ) {
			my[1] = "right"
			at[1] = "left";
			dx -= 20;
			
			if ( (pageX - offsetX) < 0) {
				my[1] = "center"
				at[1] = "center";
			}
		}
		
		if ( (pageY - offsetY) < 0 ) {
			my[0] = "top"
			at[0] = "bottom";
			dx += 5;
			dy += 15;
			
			if ( (pageY + offsetY) > window.innerHeight ) {
				my[0] = "center"
				at[0] = "center";
			}
		}	
		
		$tip.qtip("option", "position.at", at.join(" "));
		$tip.qtip("option", "position.my", my.join(" "));
		$tip.qtip("option", "position.adjust.x", dx);
		$tip.qtip("option", "position.adjust.y", dy);
	};
	
	if (!$repObj.Data.ObjId) {
		adjustTooltip();
		return $div;
	}
	
	if (!$repObj.TemplateDefinition) {
		$repObj.TemplateDefinitions(function(){ 
			$div.tooltipContent.apply($div, args);
		});
		return $div;
	}

	var $defs = $repObj.TemplateDefinition;

	if (!$defs.Tooltip) {
		api.disable(true);
		return $div.empty();
	}
	
	var $tooltipdefs = $defs.Tooltip;
	
	if (!$tooltipdefs) {
		adjustTooltip();
		return $div;
	}
		
	$.each($tooltipdefs.Content || {}, function(idx){
		$cnt.append($("<div/>")
			.css({
				"margin-bottom": "8px",
				"width": $tooltipdefs.Width,
				"display": "none"
			})
			.append($("<div/>")
				.html(this.Prompt))
			.append($("<div/>")
				.data("attribute",this.Attribute)
				.addClass("attribute")));
	});
	
	if ($cnt.children().length){
		$cnt.ajaxLoaderText();
		$repObj.init( function() {
			$cnt.find(".attribute").each( function() {
				var attr = $(this).data("attribute") || "";
				
				if (attr.match("HTMLDrawing")){
					$(this).parent().show();
					$repObj.attr(attr, null, null, $(this).height(100));
					return;
				}

				var $val = $repObj.attr(attr, null, "plaintext");

				if ($val.text()) {
					$(this).html($val).parent().show();
				}
			})
			.end()
			.ajaxLoaderText(false);
			
			if ($cnt.height()) {
				api.reposition(null, false);
			}
		});
		
		adjustTooltip();
	}
		
	return $div;	
}

$.fn.setTooltip = function () {	
	var $dom = this;
	
	var evnt = arguments[0] || null;
	var show = arguments[1] || false;
	var persistent = arguments[2] || false;
	
	if ( $dom.hasClass("disabled") ){
		return $dom;
	}
	
	if ( typeof $dom.attr("data-hasqtip") !== "undefined" ) {
		return $dom;
	}
	
	var header = $dom.data("title") || $dom.attr("title") || $dom.text();
	
	var $cnt = $("<div/>")
		.append($("<div/>").css("padding-bottom","10px"))
		.append($("<div/>")
			.css({
				"font-style": "italic",
				"text-align": "right"
			})
			.html($.LL("Click for more info") + "..."));
	
	var timer = -1;
	
	var $opts = {
		prerender: false, // Render tooltip HTML on $(document).ready()
		id: true, // Incremental numerical ID used by default
		overwrite: true, // Overwrite previous tooltips on this element
		suppress: true, // Translate 'title' to 'oldtitle' attribute (prevent browser tooltip)
		content: {
			title: header,
			attr: false,
			text: $cnt,
			button: false
		},
		position: {
			my: 'left bottom',
			at: 'top right',
			target: "mouse", // Defaults to target element
			container: false, // Defaults to $(document.body)
			viewport: false, // Requires Viewport plugin
			adjust: {
				x: 0, y: 0, // Minor x/y adjustments
				mouse: false, // Follow mouse when using target:'mouse'
				resize: false, // Reposition on resize by default
				method: 'none' // Requires Viewport plugin
			},
			effect: function(api, pos, viewport) {
				$(this).animate(pos, {
					duration: 200,
					queue: false
				});
			}
		},
		show: {
			target: false, // Defaults to target element
			event: 'mouseover', // Show on mouse over by default
			effect: true, // Use default 90ms fade effect
			delay: 100, // 90ms delay before showing
			solo: true, // Do not hide others when showing
			ready: false, // Do not show immediately
			modal: { // Requires Modal plugin
				on: false, // No modal backdrop by default
				effect: true, // Mimic show effect on backdrop
				blur: true, // Hide tooltip by clicking backdrop
				escape: true // Hide tooltip when Esc pressed
			}
		},
		hide: {
			target: false, // Defaults to target element
			event: 'mouseleave', // Hide on mouse out by default
			effect: true, // Use default 90ms fade effect
			delay: 100, // No hide delay by default
			fixed: true, // Non-hoverable by default
			inactive: false, // Do not hide when inactive
			leave: 'window', // Hide when we leave the window
			distance: false // Don't hide after a set distance
		},
		style: {
			classes: 'qtip-light qtip-shadow qtip-rounded', // No additional classes added to .qtip element
			widget: false, // Not a jQuery UI widget
			width: false, // No set width
			height: false, // No set height
			tip: { // Requires Tips plugin
				corner: true, // Use position.my by default
				mimic: false, // Don't mimic a particular corner
				width: 8, 
				height: 8,
				border: true, // Detect border from tooltip style
				offset: 0 // Do not apply an offset from corner
			}
		},
		events: {
			render: function(e,api){
				$cnt.tooltipContent($dom, e, api, evnt); 
			}, // Called when tooltip rendered
			move: null, // Called when tooltip repositioned
			show: function(e, api){
				$.async(false, timer);
			}, // Called when tooltip is about to be shown
			hide: function(e, api){ 
				if (!persistent) {
					timer = $.async(function(){
						if (api.disabled) {
							return;
						}
						api.destroy(true);
					}, 5000, false, true); 
				}
			}, // Called when tooltip is about to be hidden
			toggle: null, // Shortcut to binding to two events above
			visible: null, // Called when tooltip is shown
			hidden: null, // Called when tooltip is hidden
			focus: null, // Called when tooltip gains focus
			blur: null // Called when tooltip loses focus
		}
	};

	$dom.qtip($opts); 
	
	if (show) {
		$dom.qtip("api").show();
	}
	
	return $dom;
}

$.fn.disableTooltip = function () {
	var $dom = this;
	var disable = arguments[0];
	var timeout = arguments[1];
		
	if (typeof disable == "undefined") {
		disable = true;
	}
	
	var api = $dom.qtip("api");
	if (!api){
		if (!disable) {
			$dom.removeData("hasqtip");
			var id = $dom.attr("aria-describedby");
			if (id) {
				$("#" + id).detach().remove();
			}
		}
		return $dom;
	}
	
	if (disable) {
		api.toggle(false);
		api.disable(true);
		
		if (timeout) {
			$.async(function(){
				api.disable(false);
			}, timeout);
		}
	}
	else {
		api.destroy(true);
	}
	
	return $dom;
}

$.fn.hasOverflow = function () {
	var $dom = this;
    return dom.get(0).scrollHeight > dom.height()
        || dom.get(0).scrollWidth > dom.width();
}

$.fn.zoom = function (fn) {
	var $dom = this;
	
    $(document).bind("keydown", function (e) {
        switch (true) {
            case jQuery.browser.mozilla || jQuery.browser.msie:
                if (e.ctrlKey && (
                  e.which == 187 ||
                  e.which == 189 ||
                  e.which == 107 ||
                  e.which == 109 ||
                  e.which == 96 ||
                  e.which == 48
                )) fn();
                break;
            case jQuery.browser.opera:
                if (
                  e.which == 43 ||
                  e.which == 45 ||
                  e.which == 42 ||
                  (e.ctrlKey && e.which == 48)
              ) fn();
                break;
            case jQuery.browser.safari:
                if (e.metaKey && (
                  e.charCode == 43 ||
                  e.charCode == 45
                )) fn();
                break;
        }
        return $dom;
    });

    $(document).bind('mousewheel', function (e) {
        if (e.ctrlKey) fn();
    });

    $(document).bind('DOMMouseScroll', function (e) {
        if (e.ctrlKey) fn();
    });
	
	return $dom;
};

$.fn.findContainerSize = function() {
	var $dom = this;
	
	var value = "100%";
	var initv = null;
	
	if (!arguments.length) {
		return value;
	}
	
	var type = String(arguments[0]).toLowerCase();
	var style = String($dom.attr("style"))
		.toLowerCase()
		.replace("line-height", "");
	
	if (style.indexOf(type) > -1) {
		return parseInt($dom.css(type));
	}
	
	var $parent = $dom.parent().first();
	
	style = String($parent.attr("style"))
		.toLowerCase()
		.replace("line-height", "");
	
	if (type.match(/width/i)) {
		initv = $parent.width() || 0;
	}
	
	if (style.indexOf(type) > -1) {
		value = $parent.css(type);
		if (String(value).indexOf("%") > -1) {
			value = $parent.findContainerSize(type);	
		}
		else {
			value = parseInt(value);
		}
	}
	else if ($parent.parent().length) {
		value = $parent.findContainerSize(type);
	}
	
	if (initv) {
		value = Math.min(value, initv);
	}
	
	return value;
}

$.fn.showMedia = function() {
	if (!arguments.length) {
		return this;
	}
	
	var $dom = this;
	
	var $opts = {
		name: null,
		src: null,
		type: "image",
		width: "100%",
		height: "100%",
		autoplay: false,
		callback: $.noop,
		init: $.noop
	};
	
	if(arguments.length) {
		$.extendSafely($opts, arguments[0]);
	}
	
	if (!$opts.src) {
		return $dom;
	}
		
	switch ($opts.type) {
		case "image":
			$dom.showImage($opts);
			break;
			
		case "audio":
			$dom.showAudio($opts);
			break;
			
		case "video":
			$dom.showVideo($opts);
			break;
			
		case "pdf":		
		case "viewframe":
			$dom.append( $.initIFrameView({
				url: $opts.src,
				width: $opts.width,
				height: $opts.height
			}));
			break;
			
		default: 
			window.open($opts.src);		
			break;
	}
	
	return $dom;
}

$.fn.showImage = function() {
	if (!arguments.length) {
		return this;
	}
	
	var $dom = this;
	
	var $opts = {
		name: null,
		src: null,
		width: "100%",
		height: "100%",
		callback: $.noop
	};

	if(arguments.length) {
		$.extendSafely($opts, arguments[0]);
	}
	
	if (!$opts.src) {
		return $dom;
	}
	
	$dom
		.children()
			.css("z-index",1)
			.fadeOut(2000, function(){
				$(this).remove();
			})
			.end()
		.append( $("<img/>")	
			.attr("src", $opts.src)
			.width($opts.width)
			.height($opts.height)
			.css({
				"display": "none",
				"z-index": 2
			})
			.fadeIn(1000));
	
	return $dom;
}

$.fn.showAudio = function() {
	if (!arguments.length) {
		return this;
	}
	
	var $opts = {
		name: null,
		src: null,
		width: "100%",
		height: "100%",
		autoplay: false,
		callback: $.noop,
		init: $.noop
	};

	if(arguments.legth) {
		$.extendSafely($opts, arguments[0]);
	}
	
	if (!$opts.src) {
		return this;
	}
	
	var $dom = this;
	var type = "audio/";
	
	var filext = $opts.name.split(".");
	if (filext.length > 1) {
		type += filext.pop();
	}
	else {
		type += "mp3";
	}
	
	$opts.init.call();

	var audio = "<audio width=\"" + $opts.width + "\" height=\"" +  $opts.height + "\" type=\"" + type + "\" src=\"" + $opts.src + "\" ></video>";
	$dom.append(audio);
	
	$dom.find("audio").mediaelementplayer({
		pluginPath: "js/mediaelement/",
		success: function(media, node, player) {
			media.addEventListener("ended", function(e) {
				$opts.callback.call($dom);
			});
			if ($opts.autoplay) {
				$.async(function(){
					media.play();
				}, 1000);
			}
		}
	});
	
	return $dom;
}

$.fn.showVideo = function() {
	if (!arguments.length) {
		return this;
	}
	
	var $opts = {
		name: null,
		src: null,
		width: "100%",
		height: "100%",
		autoplay: false,
		callback: $.noop,
		init: $.noop
	};

	if (arguments.length) {
		$.extendSafely($opts, arguments[0]);
	}
	
	if (!$opts.src) {
		return this;
	}

	var $dom = this;
	var type = "video/";
	
	if (isValidUrl($opts.name) && ($opts.name.match(/you.be|youtube/i))){
		type += "youtube";
	}
	else {
		var filext = $opts.name.split(".");
		if (filext.length > 1) {
			type += filext.pop();
		}
	}
	
	if ($opts.control) {
		$dom.parents(".slidetabs").find("#pause").trigger($.browser.click);
	}
	
	$opts.init.call();
	
	if (type.match(/swf/i)) {
		var flash = "<embed width=\"" + $opts.width + "\" height=\"" +  $opts.height + "\" src=\"" + $opts.src + "\" wmode=\"transparent\" type=\"application/x-shockwave-flash\" />";
		$dom.append(flash);
	}
	else {
		var video = "<video width=\"" + $opts.width + "\" height=\"" +  $opts.height + "\" type=\"" + type + "\" src=\"" + $opts.src + "\" ></video>";
		$dom.append(video);
		
		$dom.find("video").mediaelementplayer({
			pluginPath: "js/mediaelement/",
			success: function(media, node, player) {
				media.addEventListener("ended", function(e) {
					$opts.callback.call($dom);
				});
				if ($opts.autoplay) {
					$.async(function(){
						media.play();
					}, 1000);
				}
			}
		});
	}
	
	return $dom;
}

$.fn.htmldata = function(){
	var $val = this;
	
	if (!$val.length) {
		return $val;
	}
	
	var isanc = $val.is("a");
	
	var inlinedata = function(){
		var $data = $(this).data();
		if ($.keyCount($data) > 0) {
			this.attr({
				"data-objid": $data["objid"],
				"data-name": $data["name"],
				"data-template": $data["template"],
				"data-language": $data["language"],
				"data-confid": $data["confid"],
				"data-repid": $data["repid"],
				"data-target": $data["target"]
			});
			
			if (!this.hasClass("textlink")) {
				this.setIcon();
			}
			else {
				var api = this.qtip("api");
				if (api) {
					api.destroy(true);
				}
			}
		}
	};
	
	if (isanc) {
		inlinedata.call($val);
	}
	
	$val.find("a").each(function(){
		inlinedata.call($(this));
	});
	
	return (isanc ? $val.prop("outerHTML") : $val.html());
}

jQuery(document).ready(function () {
	$ = jQuery;
	
	if (!window["$QisSession"]) {
		return;
	}
	
	if (!$QisSession.Repository) {
		return;
	}
	
	if ($QisSession.Addons) {
		$.cookie("ChatEnabled", $QisSession.Addons.QChat ? true : false);
		$.cookie("GWEEnabled", $QisSession.Addons.GWE ? true : false);	
		$.cookie("SBWEnabled", $QisSession.Addons.SBW ? true : false);
	}

	if (!$.cookie("UserSid")) {
		return endQisSession(location.href);
	}

	if ($QisSession.DEBUGMODE) {
		_START_ = (new Date()).getTime();
	}
		
	$("*").off();
	$(document).bind("keydown", $.pageKeys);
	$("#contentHeaderLeft, #contentHeaderRight").hide();
	$.initSessionParameters();
});